<?php
/**
* Fichier de configuration du package Borealis-acl
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-acl  
* @author    Pascal Martin 
* @copyright Boréal Informations Stratégiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

/**
* Fichier de configuration du package Borealis-acl 
* 
* @category PHP 
* @package  Borealis-acl
* @author   Pascal Martin 
*/ 
abstract class com_borealis_acl_Setting
{
    // --------------------------------------------------------------------------
    // DataStore configuration
    // --------------------------------------------------------------------------
    const DATASTORE = 'com_borealis_acl_datastore_PDODataStore';
    
    // --------------------------------------------------------------------------
    // XML DataStore configuration
    // --------------------------------------------------------------------------
    const XML_CONFIG_FILE = 'M:\projects\php\borealis-acl\main\src\com\borealis\acl\acl.xml';
    
    // --------------------------------------------------------------------------
    // PDO DataStore configuration
    // --------------------------------------------------------------------------
    const PDODATASTORE_DSN = 'pgsql:host=localhost;port=5432;dbname=acl;user=postgres;password=postgres';
    
    const PDODATASTORE_PREPARE_INSERT_ACTION            = 'insert into bis_acl_action (name) values (:name)';    
    const PDODATASTORE_PREPARE_DELETE_ACTION_BY_ID      = 'delete from bis_acl_action where id_action = :id';
    const PDODATASTORE_PREPARE_UPDATE_ACTION            = 'update bis_acl_action set name = :name where id_action = :id';
    const PDODATASTORE_PREPARE_SELECT_ACTION_BY_NAME    = 'select id_action as id from bis_acl_action where name = :name';
    const PDODATASTORE_PREPARE_SELECT_ACTION_BY_ID      = 'select name as name from bis_acl_action where id_action = :id';
    const PDODATASTORE_PREPARE_SELECT_ACTION_ALL        = 'select id_action as id, name as name from bis_acl_action order by name';
                                                      
    const PDODATASTORE_PREPARE_INSERT_ROLE              = 'insert into bis_acl_role (name) values (:name)';    
    const PDODATASTORE_PREPARE_DELETE_ROLE_BY_ID        = 'delete from bis_acl_role where id_role = :id';
    const PDODATASTORE_PREPARE_UPDATE_ROLE              = 'update bis_acl_role set name = :name where id_role = :id';
    const PDODATASTORE_PREPARE_SELECT_ROLE_BY_NAME      = 'select id_role as id from bis_acl_role where name = :name';
    const PDODATASTORE_PREPARE_SELECT_ROLE_BY_ID        = 'select name as name from bis_acl_role where id_role = :id';
    const PDODATASTORE_PREPARE_SELECT_ROLE_ALL          = 'select id_role as id, name as name from bis_acl_role order by name';
   
    const PDODATASTORE_PREPARE_INSERT_ROLE_MEMBER       = 'insert into bis_acl_role_member (username, id_role) values (:username, :id_role)';
    const PDODATASTORE_PREPARE_DELETE_ROLE_MEMBER       = 'delete from bis_acl_role_member where username = :username and id_role = :id_role';
    const PDODATASTORE_PREPARE_SELECT_ROLE_MEMBER       = 'select username as username from bis_acl_role_member where id_role = :id_role  order by username';
    
    const PDODATASTORE_PREPARE_INSERT_ROLE_PERMISSION           = 'insert into bis_acl_permission (id_role, id_ressource_action) values (:id_role, (select id_ressource_action from bis_acl_ressource_action where id_ressource = :id_ressource and id_action = :id_action) )';
    const PDODATASTORE_PREPARE_DELETE_ROLE_PERMISSION           = 'delete from bis_acl_permission where id_role = :id_role and id_ressource_action = (select id_ressource_action from bis_acl_ressource_action where id_ressource = :id_ressource and id_action = :id_action)';   
    const PDODATASTORE_PREPARE_SELECT_ROLE_PERMISSION_ACTION    = 'select a.id_action as id, a.name as name from bis_acl_permission as p inner join bis_acl_ressource_action as ra on p.id_ressource_action = ra.id_ressource_action inner join bis_acl_action as a on ra.id_action = a.id_action where p.id_role = :id_role order by ra.id_ressource_action';
    const PDODATASTORE_PREPARE_SELECT_ROLE_PERMISSION_RESSOURCE = 'select r.id_ressource as id, r.name as name from bis_acl_permission as p inner join bis_acl_ressource_action as ra on p.id_ressource_action = ra.id_ressource_action inner join bis_acl_ressource as r on ra.id_ressource = r.id_ressource where p.id_role = :id_role order by ra.id_ressource_action';
                                                
    const PDODATASTORE_PREPARE_INSERT_RESSOURCE         = 'insert into bis_acl_ressource (name) values (:name)';    
    const PDODATASTORE_PREPARE_DELETE_RESSOURCE_BY_ID   = 'delete from bis_acl_ressource where id_ressource = :id';
    const PDODATASTORE_PREPARE_UPDATE_RESSOURCE         = 'update bis_acl_ressource set name = :name where id_ressource = :id';
    const PDODATASTORE_PREPARE_SELECT_RESSOURCE_BY_NAME = 'select id_ressource as id from bis_acl_ressource where name = :name';
    const PDODATASTORE_PREPARE_SELECT_RESSOURCE_BY_ID   = 'select name as name from bis_acl_ressource where id_ressource = :id';
    const PDODATASTORE_PREPARE_SELECT_RESSOURCE_ALL     = 'select id_ressource as id, name as name from bis_acl_ressource order by name'; 
    
    const PDODATASTORE_PREPARE_INSERT_RESSOURCE_ACTION  = 'insert into bis_acl_ressource_action (id_ressource, id_action) values (:id_ressource, :id_action)';    
    const PDODATASTORE_PREPARE_DELETE_RESSOURCE_ACTION  = 'delete from bis_acl_ressource_action where id_ressource = :id_ressource and id_action = :id_action';    
    const PDODATASTORE_PREPARE_SELECT_RESSOURCE_ACTION  = 'select a.id_action as id, name as name from bis_acl_ressource_action as r inner join bis_acl_action as a on r.id_action = a.id_action where r.id_ressource = :id_ressource';    
    
    const PDODATASTORE_PREPARE_SELECT_AUTHORIZED  = 'select rm.id_role_member from bis_acl_role_member as rm inner join bis_acl_permission as p on p.id_role = rm.id_role inner join bis_acl_ressource_action as ra on p.id_ressource_action = ra.id_ressource_action where username = :username and ra.id_ressource = :id_ressource and ra.id_action = :id_action';    
    
}
  
?>
