<?php
/**
* Classe de base qui reprsente un session
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-security  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

/**
* Classe de base qui reprsente un session
* 
* @category   PHP 
* @package    Borealis-security
* @subpackage Session
* @author     Pascal Martin 
*/
abstract class com_borealis_security_session_Session
{
    private $m_strUsername;
    
    /**
    * Construit une nouvelle instance de com_borealis_security_session_Session
    * 
    * @param string $pstrUsername Nom d'utilisateur 
    * 
    * @throws com_borealis_security_IllegalArgumentException 
    * 
    * @return com_borealis_security_session_Session
    */
    function __construct($pstrUsername) 
    {
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrUsername);
        $this->m_strUsername = $pstrUsername;  
    }

    /**
    * Retourne le username lier  la session
    * 
    * @return string Session username
    */
    public function getUsername()
    {
        return $this->m_strUsername;        
    }    
}
  
?>
