<?php
/**
* Setter et getter pour la configuration
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-acl  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.boreal-is.com/license BSD License
* @link      http://www.boreal-is.com
*/

/**
* Setter et getter pour la configuration
* 
* @category PHP 
* @package  Borealis-acl
* @author   Pascal Martin 
*/ 
class com_borealis_acl_SettingImpl extends com_borealis_acl_Setting
{
    private static $s_strXMLConfigFile                         = self::XML_CONFIG_FILE;      

    private static $s_strDataStore                             = self::DATASTORE;
    
    private static $s_strPDODataStoreDSN                       = self::PDODATASTORE_DSN;
    
    private static $s_strWebServiceDataStoreWSDL               = self::WEBSERVICE_DATASTORE_WSDL;
    
    private static $s_strWebServiceDataStoreConnLookup         = self::WEBSERVICE_DATASTORE_CONN_LOOKUP;

    private static $s_strDataStorePrepareInsertAction          = self::DATASTORE_PREPARE_INSERT_ACTION;
    private static $s_strDataStorePrepareDeleteActionByID      = self::DATASTORE_PREPARE_DELETE_ACTION_BY_ID;     
    private static $s_strDataStorePrepareUpdateAction          = self::DATASTORE_PREPARE_UPDATE_ACTION; 
    private static $s_strDataStorePrepareSelectActionByName    = self::DATASTORE_PREPARE_SELECT_ACTION_BY_NAME; 
    private static $s_strDataStorePrepareSelectActionByID      = self::DATASTORE_PREPARE_SELECT_ACTION_BY_ID; 
    private static $s_strDataStorePrepareSelectActionAll       = self::DATASTORE_PREPARE_SELECT_ACTION_ALL; 
    
    private static $s_strDataStorePrepareInsertRole            = self::DATASTORE_PREPARE_INSERT_ROLE;
    private static $s_strDataStorePrepareDeleteRoleByID        = self::DATASTORE_PREPARE_DELETE_ROLE_BY_ID;     
    private static $s_strDataStorePrepareUpdateRole            = self::DATASTORE_PREPARE_UPDATE_ROLE; 
    private static $s_strDataStorePrepareSelectRoleByName      = self::DATASTORE_PREPARE_SELECT_ROLE_BY_NAME; 
    private static $s_strDataStorePrepareSelectRoleByID        = self::DATASTORE_PREPARE_SELECT_ROLE_BY_ID; 
    private static $s_strDataStorePrepareSelectRoleAll         = self::DATASTORE_PREPARE_SELECT_ROLE_ALL;
    
    private static $s_strDataStorePrepareInsertRoleMember      = self::DATASTORE_PREPARE_INSERT_ROLE_MEMBER;
    private static $s_strDataStorePrepareDeleteRoleMember      = self::DATASTORE_PREPARE_DELETE_ROLE_MEMBER;
    private static $s_strDataStorePrepareSelectRoleMember      = self::DATASTORE_PREPARE_SELECT_ROLE_MEMBER;
                                                                       
    private static $s_strDataStorePrepareInsertRolePermission          = self::DATASTORE_PREPARE_INSERT_ROLE_PERMISSION;
    private static $s_strDataStorePrepareDeleteRolePermission          = self::DATASTORE_PREPARE_DELETE_ROLE_PERMISSION;
    private static $s_strDataStorePrepareSelectRolePermissionAction    = self::DATASTORE_PREPARE_SELECT_ROLE_PERMISSION_ACTION;
    private static $s_strDataStorePrepareSelectRolePermissionRessource = self::DATASTORE_PREPARE_SELECT_ROLE_PERMISSION_RESSOURCE;
    
    private static $s_strDataStorePrepareInsertRessource       = self::DATASTORE_PREPARE_INSERT_RESSOURCE;
    private static $s_strDataStorePrepareDeleteRessourceByID   = self::DATASTORE_PREPARE_DELETE_RESSOURCE_BY_ID;     
    private static $s_strDataStorePrepareUpdateRessource       = self::DATASTORE_PREPARE_UPDATE_RESSOURCE; 
    private static $s_strDataStorePrepareSelectRessourceByName = self::DATASTORE_PREPARE_SELECT_RESSOURCE_BY_NAME; 
    private static $s_strDataStorePrepareSelectRessourceByID   = self::DATASTORE_PREPARE_SELECT_RESSOURCE_BY_ID; 
    private static $s_strDataStorePrepareSelectRessourceAll    = self::DATASTORE_PREPARE_SELECT_RESSOURCE_ALL;
    
    private static $s_strDataStorePrepareInsertRessourceAction = self::DATASTORE_PREPARE_INSERT_RESSOURCE_ACTION;
    private static $s_strDataStorePrepareDeleteRessourceAction = self::DATASTORE_PREPARE_DELETE_RESSOURCE_ACTION;
    private static $s_strDataStorePrepareSelectRessourceAction = self::DATASTORE_PREPARE_SELECT_RESSOURCE_ACTION; 
    
    private static $s_strDataStorePrepareSelectAuthorized      = self::DATASTORE_PREPARE_SELECT_AUTHORIZED; 
    
    
    
    // --------------------------
    // Getter
    // --------------------------
    
    /**
    * Return XMLConfigFile
    * 
    * @return string
    */
    public static function getXMLConfigFile()
    {
         return self::$s_strXMLConfigFile;
    }
    
    /**
    * Return DataStore
    * 
    * @return string
    */
    public static function getDataStore()
    {
         return self::$s_strDataStore;
    } 
    
    /**
    * Return PDODataStoreDSN
    * 
    * @return string
    */
    public static function getPDODataStoreDSN()
    {
         return self::$s_strPDODataStoreDSN;
    }
    
    /**
    * Return WebServiceDataStoreWSDL
    * 
    * @return string
    */
    public static function getWebServiceDataStoreWSDL()
    {
         return self::$s_strWebServiceDataStoreWSDL;
    }
    
    /**
    * Return WebServiceDataStoreConnectionLookup
    * 
    * @return string
    */
    public static function getWebServiceDataStoreConnectionLookup()
    {
         return self::$s_strWebServiceDataStoreConnLookup;
    } 
    
    /**
    * Return PDODataStorePrepareSelectAuthorized
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectAuthorized()
    {
         return self::$s_strDataStorePrepareSelectAuthorized;
    }    
    
    // --------------
    // action 
    // --------------
    
    /**
    * Return PDODataStorePrepareInsertAction
    * 
    * @return string
    */
    public static function getDataStorePrepareInsertAction()
    {
         return self::$s_strDataStorePrepareInsertAction;
    }
    
    /**
    * Return PDODataStorePrepareDeleteActionByID
    * 
    * @return string
    */
    public static function getDataStorePrepareDeleteActionByID()
    {
         return self::$s_strDataStorePrepareDeleteActionByID;
    }
    
    /**
    * Return PDODataStorePrepareUpdateAction
    * 
    * @return string
    */
    public static function getDataStorePrepareUpdateAction()
    {
         return self::$s_strDataStorePrepareUpdateAction;
    }
    
    /**
    * Return PDODataStorePrepareSelectActionByName
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectActionByName()
    {
         return self::$s_strDataStorePrepareSelectActionByName;
    }
    
    /**
    * Return PDODataStorePrepareSelectActionByID
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectActionByID()
    {
         return self::$s_strDataStorePrepareSelectActionByID;
    }
    
    /**
    * Return PDODataStorePrepareSelectActionAll
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectActionAll()
    {
         return self::$s_strDataStorePrepareSelectActionAll;
    }

    // --------------
    // Role
    // --------------
    
    /**
    * Return PDODataStorePrepareInsertRole
    * 
    * @return string
    */
    public static function getDataStorePrepareInsertRole()
    {
         return self::$s_strDataStorePrepareInsertRole;
    }
    
    /**
    * Return PDODataStorePrepareDeleteRoleByID
    * 
    * @return string
    */
    public static function getDataStorePrepareDeleteRoleByID()
    {
         return self::$s_strDataStorePrepareDeleteRoleByID;
    }
    
    /**
    * Return PDODataStorePrepareUpdateRole
    * 
    * @return string
    */
    public static function getDataStorePrepareUpdateRole()
    {
         return self::$s_strDataStorePrepareUpdateRole;
    }
    
    /**
    * Return PDODataStorePrepareSelectRoleByName
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRoleByName()
    {
         return self::$s_strDataStorePrepareSelectRoleByName;
    }
    
    /**
    * Return PDODataStorePrepareSelectRoleByID
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRoleByID()
    {
         return self::$s_strDataStorePrepareSelectRoleByID;
    }
    
    /**
    * Return PDODataStorePrepareSelectRoleAll
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRoleAll()
    {
         return self::$s_strDataStorePrepareSelectRoleAll;
    }
    
    /**
    * Return PDODataStorePrepareInsertRoleMember
    * 
    * @return string
    */
    public static function getDataStorePrepareInsertRoleMember()
    {
         return self::$s_strDataStorePrepareInsertRoleMember;
    }
    
    /**
    * Return PDODataStorePrepareDeleteRoleMember
    * 
    * @return string
    */
    public static function getDataStorePrepareDeleteRoleMember()
    {
         return self::$s_strDataStorePrepareDeleteRoleMember;
    } 
    
    /**
    * Return PDODataStorePrepareSelectRoleMember
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRoleMember()
    {
         return self::$s_strDataStorePrepareSelectRoleMember;
    } 
    
    /**
    * Return PDODataStorePrepareInsertRolePermission
    * 
    * @return string
    */
    public static function getDataStorePrepareInsertRolePermission()
    {
         return self::$s_strDataStorePrepareInsertRolePermission;
    }
    
    /**
    * Return PDODataStorePrepareDeleteRolePermission
    * 
    * @return string
    */
    public static function getDataStorePrepareDeleteRolePermission()
    {
         return self::$s_strDataStorePrepareDeleteRolePermission;
    }
      
    /**
    * Return PDODataStorePrepareSelectRolePermissionAction
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRolePermissionAction()
    {
         return self::$s_strDataStorePrepareSelectRolePermissionAction;
    }
    
    /**
    * Return PDODataStorePrepareSelectRolePermissionRessource
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRolePermissionRessource()
    {
         return self::$s_strDataStorePrepareSelectRolePermissionRessource;
    }
    
    // --------------
    // Ressource
    // --------------
    
    /**
    * Return PDODataStorePrepareInsertRessource
    * 
    * @return string
    */
    public static function getDataStorePrepareInsertRessource()
    {
         return self::$s_strDataStorePrepareInsertRessource;
    }
    
    /**
    * Return PDODataStorePrepareDeleteRessourceByID
    * 
    * @return string
    */
    public static function getDataStorePrepareDeleteRessourceByID()
    {
         return self::$s_strDataStorePrepareDeleteRessourceByID;
    }
    
    /**
    * Return PDODataStorePrepareUpdateRessource
    * 
    * @return string
    */
    public static function getDataStorePrepareUpdateRessource()
    {
         return self::$s_strDataStorePrepareUpdateRessource;
    }
    
    /**
    * Return PDODataStorePrepareSelectRessourceByName
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRessourceByName()
    {
         return self::$s_strDataStorePrepareSelectRessourceByName;
    }
    
    /**
    * Return PDODataStorePrepareSelectRessourceByID
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRessourceByID()
    {
         return self::$s_strDataStorePrepareSelectRessourceByID;
    } 
    
    /**
    * Return PDODataStorePrepareSelectRessourceAll
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRessourceAll()
    {
         return self::$s_strDataStorePrepareSelectRessourceAll;
    }
    
    /**
    * Return PDODataStorePrepareInsertRessourceAction
    * 
    * @return string
    */
    public static function getDataStorePrepareInsertRessourceAction()
    {
         return self::$s_strDataStorePrepareInsertRessourceAction;
    }
    
    /**
    * Return PDODataStorePrepareDeleteRessourceAction
    * 
    * @return string
    */
    public static function getDataStorePrepareDeleteRessourceAction()
    {
         return self::$s_strDataStorePrepareDeleteRessourceAction;
    }

    /**
    * Return PDODataStorePrepareSelectRessourceAction
    * 
    * @return string
    */
    public static function getDataStorePrepareSelectRessourceAction()
    {
         return self::$s_strDataStorePrepareSelectRessourceAction;
    }
    
    // --------------------------
    // Setter
    // --------------------------
    
    /**
    * Set XMLConfigFile
    * 
    * @param string $pstrValue Value
    * 
    * @return void
    */
    public static function setXMLConfigFile($pstrValue)
    {
         self::$s_strXMLConfigFile = $pstrValue;
    }   
    
    /**
    * Set DataStore
    * 
    * @param string $pstrValue Value
    * 
    * @return void
    */
    public static function setDataStore($pstrValue)
    {
         self::$s_strDataStore = $pstrValue;
    } 
    
    
    /**
    * Set PDODataStoreDSN
    * 
    * @param string $pstrValue Value
    * 
    * @return void
    */
    public static function setPDODataStoreDSN($pstrValue)
    {
         self::$s_strPDODataStoreDSN = $pstrValue;
    } 
        
    /**
    * Define the connection lookup to use from tomcat
    * 
    * @param mixed $pstrConnectionLookup String representing the connectionLookup in Tomcat configurations
    * 
    * @return void
    */
    public static function setWebServiceDataStoreConnectionLookup($pstrConnectionLookup)
    {
         self::$s_strWebServiceDataStoreConnLookup = $pstrConnectionLookup;
    }
    
    /**
    * Define the endPoint for the WebService WSDL
    * 
    * @param string $pstrWebServiceWSDL Value
    * 
    * @return void
    */
    public static function setWebServiceDataStoreWSDL($pstrWebServiceWSDL)
    {
         self::$s_strWebServiceDataStoreWSDL = $pstrWebServiceWSDL;
    }
    
}
  
?>
