<?php
/**
* Class de base pour les factory de manager
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-acl  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.boreal-is.com/license BSD License
* @link      http://www.boreal-is.com
*/
    
/**
* Class de base pour les factory de manager
* 
* @category   PHP 
* @package    Borealis-acl
* @subpackage DataStore
* @author     Pascal Martin
*/
class com_borealis_acl_datastore_DataStoreFactory extends com_borealis_foundation_manager_Factory
{
    /**
    * Construit une nouvelle instance de com_borealis_acl_datastore_DataStoreFactory 
    * 
    * @return com_borealis_acl_datastore_DataStoreFactory
    */
    private function __construct() 
    {
        // vide
    }
    
    /**
    * Return a DataStore
    * 
    * @return com_borealis_acl_datastore_DataStore
    */
    public static function getDataStore()
    {
        $objManagerFactory = new com_borealis_acl_datastore_DataStoreFactory(); 
        return $objManagerFactory->getManager(com_borealis_acl_SettingImpl::getDataStore());
    }
    
    /**
    * Vérifie que l'object passer est un instance de com_borealis_security_manager_authentication_AuthenticationManager
    * 
    * @param object $pobjManager object to test
    * 
    * @return bool
    */            
    protected function isGoodInstance($pobjManager)
    {
        return $pobjManager instanceof com_borealis_acl_datastore_DataStore;  
    }
    
    /**
    * Retourne une erreur
    * 
    * @param string $pstrMessage Message erreur
    * 
    * @return com_borealis_security_exception_BadAuthenticationManagerException
    */
    protected function getError($pstrMessage)
    {
        return new com_borealis_acl_exception_BadDataStoreException($pstrMessage);   
    }  
}
    
    
?>