<?php
/**
* Gestionnaire d'utilisateur
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-authentication
* @author    Pascal Martin 
* @copyright Boréal Informations Stratégiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

/**
* Gestionnaire d'utilisateur        
* 
* @category   PHP 
* @package    Borealis-authentication
* @subpackage Authentication  
* @author     Pascal Martin 
*/ 
class com_borealis_authentication_AuthenticationManager
{
    /**
    * Vérifie le doit d'authentification
    * 
    * @param string $pstrUsername Nom d'utilisateur
    * @param string $pstrPassword Mot de passe
    * 
    * @return boolean Authorized 
    */
    public static function isAuthorized($pstrUsername, $pstrPassword)
    {
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrUsername);
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrPassword);
        
        $objArrayChecker = com_borealis_authentication_SettingImpl::getCheckers();
            
        $bResult = false;                       
        foreach ($objArrayChecker as $objChecker)
        {
            if ($objChecker instanceof com_borealis_authentication_checker_Checker)
            {
                $bResult = $bResult || $objChecker->isAuthorized($pstrUsername, $pstrPassword);
            }                                 
        }
        return $bResult;    
    }  
}    

?>