<?php
/**
* Setter et getter pour la configuration
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-users  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.boreal-is.com/license BSD License
* @link      http://www.boreal-is.com
*/

/**
* Setter et getter pour la configuration
* 
* @category   PHP 
* @package    Borealis-users
* @subpackage Setting   
* @author     Pascal Martin 
*/ 
class com_borealis_users_SettingImpl extends com_borealis_users_Setting
{
    private static $s_objArrayDatastores = array();
    
    /**
    * Retourne la liste des datastore a utiliser pour récupérer les utilisateur
    * 
    * @return array 
    */
    public static function getDatastores()
    {
        return self::$s_objArrayDatastores;   
    }
    
    /**
    * Set la liste des datastore a utiliser pour récupérer les utilisateur
    * 
    * @param array $pobjArrayDatastores Liste d'object com_borealis_users_datastore_DataStore
    * 
    * @return void 
    */
    public static function setDatastores(array $pobjArrayDatastores)
    {   
        self::$s_objArrayDatastores = $pobjArrayDatastores;                                            
    }   
}
  
?>