<?php
/**
* Fichier php pour le l'affichage de la section de test de l'acl pour un utilisateur
*
* PHP versions 5
* 
* @category  PHP
* @package   ACL  
* @author    Pascal Martin 
* @copyright Boréal Informations Stratégiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

// -----------------------------------------------
// --- Include
// -----------------------------------------------
require_once 'common.php'; 

// -----------------------------------------------
// --- Set domain
// -----------------------------------------------
bindtextdomain("aclmanager", $g_strLanguageDir);
textdomain("aclmanager"); 
bind_textdomain_codeset("aclmanager", "UTF-8");

// -----------------------------------------------
// --- Variable global
// -----------------------------------------------
$g_bIsAuthorized = null; 
$g_strErrorIsAuthorized = '';   
$g_objAction = null;
$g_objResource = null;

// -----------------------------------------------
// --- Action
// -----------------------------------------------

/**
* Vérifie si l'utilisateur a les droit d'acces pour la ressource et l'action spécifier
*   $_REQUEST['username']
*   $_REQUEST['ressourceid']
*   $_REQUEST['actionid']
* 
* @return void
*/
function isAuthorized()
{
    global $g_bIsAuthorized;
    global $g_strErrorIsAuthorized;
    global $g_objAction;
    global $g_objResource;
    
    if (trim($_REQUEST['username']) == '')
    {
        $g_strErrorIsAuthorized = gettext('empty_username');
        return;    
    }
    
    $g_objResource = com_borealis_acl_object_Ressource::getByID((int)$_REQUEST['ressourceid']);
    $g_objAction = com_borealis_acl_object_Action::getByID((int)$_REQUEST['actionid']);        
  
    $g_bIsAuthorized = com_borealis_acl_manager_ACLManager::isAuthorized($_REQUEST['username'], $g_objResource, $g_objAction);       
}
    
if (isset($_REQUEST['action']))
{   
    switch($_REQUEST['action'])
    {
        case 'is_authorized':
            isAuthorized();
            break;
    }
}

// -----------------------------------------------
// --- Initialisation
// -----------------------------------------------
if (!isset($_REQUEST['username']))
{   
    $_REQUEST['username'] = '';    
}
if (!isset($_REQUEST['actionid']))
{   
    $_REQUEST['actionid'] = '';    
}
if (!isset($_REQUEST['ressourceid']))
{   
    $_REQUEST['ressourceid'] = '';    
}

// -----------------------------------------------
// --- Smarty display
// -----------------------------------------------
$g_objSmarty->assign('action', $g_objAction);  
$g_objSmarty->assign('ressource', $g_objResource);  
$g_objSmarty->assign('actionid', $_REQUEST['actionid']); 
$g_objSmarty->assign('ressourceid', $_REQUEST['ressourceid']); 
$g_objSmarty->assign('username', $_REQUEST['username']);   
$g_objSmarty->assign('actions', com_borealis_acl_object_Action::getAll()); 
$g_objSmarty->assign('ressources', com_borealis_acl_object_Ressource::getAll());     
$g_objSmarty->assign('isAuthorized', $g_bIsAuthorized); 
$g_objSmarty->assign('errorIsAuthorized', $g_strErrorIsAuthorized); 
                                                                                                  
$g_objSmarty->display('aclmanager.tpl');
  
?>