// === sampleMethods : used by buttons in the demo ===

var sampleMethods = [];

// [0] GeoPrisma.getCenter()
sampleMethods.push(function(){
    alert(Ext.encode(GeoPrisma.getCenter()));
});

// [1] GeoPrisma.setCenter() using hardcoded values (on Saguenay)
sampleMethods.push(function(){
    GeoPrisma.setCenter({
        x: -7912983,
        y: 6176194,
        zoom: 10
    });
});

// [2] GeoPrisma.setCenter() using inputed values
sampleMethods.push(function(){
    GeoPrisma.setCenter({
        x: parseFloat(Ext.get("x").dom.value),
        y: parseFloat(Ext.get("y").dom.value),
        zoom: parseInt(Ext.get("z").dom.value),
        projection: Ext.get("p").dom.value
    });
});


// === events : demonstrate how to listen to some 'center' related events of ===
// === the API widget ===

Ext.onReady(function() {
    GeoPrisma.on("centerchanged", function(values) {
        Ext.get("x").dom.value = values.x;
        Ext.get("y").dom.value = values.y;
        Ext.get("z").dom.value = values.zoom;
        Ext.get("p").dom.value = values.projection;
    }, this);
});
