// === sampleMethods : used by buttons in the demo ===

var sampleMethods = [];

// [0] GeoPrisma.setCenter() using hardcoded values (on Saguenay)
sampleMethods.push(function(){
    GeoPrisma.setCenter({
        x: -7912983,
        y: 6176194,
        zoom: 10
    });
});

// === events ===
// demonstrate how to listen to the "centermarkerchanged" event using the API
// widget and also to reproject the returned values if needed

Ext.onReady(function() {
    GeoPrisma.on("centermarkerchanged", function(values) {
        var text = [];
        if (!values.x || !values.y) {
            text.push("N/A");
        } else {
            // reproject first
            var point = new OpenLayers.LonLat(values.x, values.y).transform(
                new OpenLayers.Projection("EPSG:900913"),
                new OpenLayers.Projection(currentProjection)
            );
            text.push(" x: ");
            text.push(point.lon);
            text.push(" y: ");
            text.push(point.lat);
        }
        Ext.get("markerPos").dom.innerHTML = text.join("");
    }, this);
});

var projections = ["EPSG:4326", "EPSG:900913"];
var currentProjection = projections[0];
function toggleProjection(element) {
    for (var i=0, iLen=projections.length; i<iLen; i++) {
        if (element.value == projections[i] && element.checked) {
            currentProjection = projections[i];
            break;
        }
    }
}
