#!/usr/bin/python
"""
    ADAPTED FROM : http://cci.lbl.gov/~phzwart/collaborate/moin-1.5.5a/MoinMoin/i18n/prepend.py

    Prepend some string (processing instructions, licence info, etc.) to a file (.js, .php or .xslt)

    To apply to a particular file, use this command :

    /home/yves/geoprisma/trunk/script/prepend-license-utf8.py filename

    To apply to all files in a particular folder, use this command : 

    for f in *; do /home/yves/geoprisma/trunk/script/prepend-license-utf8.py $f; done

    To recursively go through files from the current directory location, use :

    find `pwd` -name '*.*' -exec /home/yves/geoprisma/trunk/script/prepend-license-utf8.py '{}' \;

    NOTE : find . -name '*.*' will list files with a relative path starting with ./ that is not
    compatible with this script
    To avoid that `pwd` will output file names with their absolute path
"""
def run():
    import sys, codecs
    fname = sys.argv[1]

    textjsphp = u"""\
/* \n   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. \n*/ \n""" 

    textxslt = u"""\
<!-- \n   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.\n --> \n"""

#    lang = fname.replace('.txt_', '').replace('.txt', '')
#    lang = lang.replace('_', '-') # module names use _ instead of -

    if (fname.partition('.')[-1] == 'js') or (fname.partition('.')[-1] == 'php') or (fname.partition('.')[-1] == 'xslt'):
        f = codecs.open(fname, 'r', 'utf-8')
        lines = f.readlines()
        f.close()


    if (fname.partition('.')[-1] == 'js'):
        lines.insert(0,textjsphp)
        s = ''.join(lines)
        f = codecs.open(fname, 'w', 'utf-8')
        f.write(s)
        f.close()
        print fname + " : license added"
    elif (fname.partition('.')[-1] == 'php'):
        lines.insert(1,textjsphp)
        s = ''.join(lines)
        f = codecs.open(fname, 'w', 'utf-8')
        f.write(s)
        f.close()
        print fname + " : license added"
    elif (fname.partition('.')[-1] == 'xslt'):
        lines.insert(1,textxslt)
        s = ''.join(lines)
        f = codecs.open(fname, 'w', 'utf-8')
        f.write(s)
        f.close()
        print fname + " : license added"
    
if __name__ == "__main__":
    run()


