@echo OFF

cls

set PARAM_VERSION=trunk
set PARAM_DIR=../releases

IF NOT [%1]==[] set PARAM_VERSION=%1
IF NOT [%2]==[] set PARAM_DIR=%2

PUSHD ".."
svn.exe info | grep Revision | cut -c 11- > svninfo.txt
set /p GEOPRISMA_REV=<svninfo.txt
del /s/q svninfo.txt
POPD

IF [%1]==[trunk] set PARAM_VERSION=r%GEOPRISMA_REV%

set RELEASE_VERSION=%PARAM_VERSION%
set RELEASE_DIR=%PARAM_DIR%/geoprisma-%RELEASE_VERSION%
set RELEASE_GEOPRISMA_core=%RELEASE_DIR%\lib\geoprisma-%RELEASE_VERSION%
set RELEASE_GEOPRISMA_LIB=%RELEASE_DIR%\lib
set RELEASE_GEOPRISMA_SAMPLES=%RELEASE_DIR%\samples
set RELEASE_GEOPRISMA_CONFIG=%RELEASE_DIR%\config
set SRC_LIB=../lib


IF EXIST "%RELEASE_DIR%.zip" rm "%RELEASE_DIR%.zip"
IF EXIST "%RELEASE_DIR%.7z" rm "%RELEASE_DIR%.7z"
IF EXIST "%RELEASE_DIR%" rmdir /s/q "%RELEASE_DIR%"

IF NOT EXIST "%RELEASE_DIR%" mkdir "%RELEASE_DIR%"

rem ------------------------------------------------------------------------------------------------------------------------------------------
rem 						geoprisma
rem ------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXIST "%RELEASE_GEOPRISMA_CORE%" mkdir "%RELEASE_GEOPRISMA_CORE%"

echo.
echo *****************************
echo ** Release - GeoPrisma src **
echo *****************************
xcopy "../languages" "%RELEASE_GEOPRISMA_CORE%\languages\" /S /Q
xcopy "../src" "%RELEASE_GEOPRISMA_CORE%\src\" /S /Q

rem ------------------------------------------------------------------------------------------------------------------------------------------
rem 						geoprisma-sample
rem ------------------------------------------------------------------------------------------------------------------------------------------
echo.
echo *********************************
echo ** Release - GeoPrisma samples **
echo *********************************

IF NOT EXIST "%RELEASE_GEOPRISMA_SAMPLES%" mkdir "%RELEASE_GEOPRISMA_SAMPLES%"
IF NOT EXIST "%RELEASE_GEOPRISMA_CONFIG%" mkdir "%RELEASE_GEOPRISMA_CONFIG%"

xcopy "../samples" "%RELEASE_GEOPRISMA_SAMPLES%\" /S /Q
xcopy "../config" "%RELEASE_GEOPRISMA_CONFIG%\" /S /Q

rem ------------------------------------------------------------------------------------------------------------------------------------------
rem 						geoprisma-lib
rem ------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXIST "%RELEASE_GEOPRISMA_LIB%" mkdir "%RELEASE_GEOPRISMA_LIB%"

rem ----------------------------------
rem OpenLayer lib
rem ----------------------------------

echo.
echo **************************
echo ** Release - Openlayers **
echo **************************

set OPENLAYER_SRC=%SRC_LIB%\externals\mapfish-client-trunk\mfbase\openlayers

PUSHD "%OPENLAYER_SRC%"
svn.exe info | grep Revision | cut -c 11- > svninfo.txt
set /p OPENLAYERS_REV=<svninfo.txt
del /s/q svninfo.txt
POPD

set OPENLAYER_DST=%RELEASE_GEOPRISMA_LIB%\openlayers-r%OPENLAYERS_REV%
IF NOT EXIST "%OPENLAYER_DST%" mkdir "%OPENLAYER_DST%"

xcopy "%OPENLAYER_SRC%\lib\OpenLayers.js" "%OPENLAYER_DST%\lib\" /Q
xcopy "%OPENLAYER_SRC%\lib\OpenLayers" "%OPENLAYER_DST%\lib\OpenLayers\" /S /Q
xcopy "%OPENLAYER_SRC%\lib\Rico" "%OPENLAYER_DST%\lib\Rico\" /S /Q
xcopy "%OPENLAYER_SRC%\theme" "%OPENLAYER_DST%\theme\" /S /Q
xcopy "%OPENLAYER_SRC%\img" "%OPENLAYER_DST%\img\" /S /Q

rem ----------------------------------
rem Mapfish client lib
rem ----------------------------------

echo.
echo ***********************
echo ** Release - Mapfish **
echo ***********************

set MAPFISH_SRC=%SRC_LIB%\externals\mapfish-client-trunk

PUSHD "%MAPFISH_SRC%"
svn.exe info | grep Revision | cut -c 11- > svninfo.txt
set /p MAPFISH_REV=<svninfo.txt
del /s/q svninfo.txt
POPD

set MAPFISH_DST=%RELEASE_GEOPRISMA_LIB%\mapfish-r%MAPFISH_REV%
IF NOT EXIST "%MAPFISH_DST%" mkdir "%MAPFISH_DST%"

xcopy "%MAPFISH_SRC%\mfbase\mapfish\img" "%MAPFISH_DST%\img\" /S /Q
xcopy "%MAPFISH_SRC%\mfbase\mapfish\lang" "%MAPFISH_DST%\lang\" /S /Q
xcopy "%MAPFISH_SRC%\mfbase\mapfish\core" "%MAPFISH_DST%\core\" /S /Q
xcopy "%MAPFISH_SRC%\mfbase\mapfish\widgets" "%MAPFISH_DST%\widgets\" /S /Q
xcopy "%MAPFISH_SRC%\mfbase\mapfish\MapFish.js" "%MAPFISH_DST%\" /Q
xcopy "%MAPFISH_SRC%\mfbase\mapfish\mapfish.css" "%MAPFISH_DST%\" /Q

rem ----------------------------------
rem GeoExt lib
rem ----------------------------------
rem set GEOEXT_VERSION=trunk

echo.
echo **********************
echo ** Release - GeoExt **
echo **********************

set GEOEXT_SRC=%SRC_LIB%\externals\geoext-core

PUSHD "%GEOEXT_SRC%"
svn.exe info | grep Revision | cut -c 11- > svninfo.txt
set /p GEOEXT_REV=<svninfo.txt
del /S/Q svninfo.txt
POPD

set GEOEXT_DST=%RELEASE_GEOPRISMA_LIB%\geoext-r%GEOEXT_REV%
IF NOT EXIST "%GEOEXT_DST%" mkdir "%GEOEXT_DST%"

xcopy "%GEOEXT_SRC%\lib" "%GEOEXT_DST%\lib\" /S /Q
xcopy "%GEOEXT_SRC%\resources" "%GEOEXT_DST%\resources\" /S /Q

rem ----------------------------------
rem geoextux_shortcutcombo 
rem ----------------------------------
rem set GEOEXTUXSHORTCUTCOMBO_VERSION=trunk

echo.
echo **************************************
echo ** Release - GeoExtux_shortcutcombo **
echo **************************************

set GEOEXTUXSHORTCUTCOMBO_SRC=%SRC_LIB%\externals\geoext-ux-shortcutcombo

PUSHD "%GEOEXTUXSHORTCUTCOMBO_SRC%"
svn.exe info | grep R.vision | cut -c 11- > svninfo.txt
set /p GEOEXTUXSHORTCUTCOMBO_REV=<svninfo.txt
del /S/Q svninfo.txt
POPD

set GEOEXTUXSHORTCUTCOMBO_DST=%RELEASE_GEOPRISMA_LIB%\geoextux_shortcutcombo-r%GEOEXTUXSHORTCUTCOMBO_REV%
IF NOT EXIST "%GEOEXTUXSHORTCUTCOMBO_DST%" mkdir "%GEOEXTUXSHORTCUTCOMBO_DST%"

xcopy "%GEOEXTUXSHORTCUTCOMBO_SRC%\ux\" "%GEOEXTUXSHORTCUTCOMBO_DST%\lib\" /S /Q

rem ----------------------------------
rem extjs lib
rem ----------------------------------

echo.
echo *********************
echo ** Release - ExtJs **
echo *********************

set EXTJS_VERSION=3.0.0
set EXTJS_DST=%RELEASE_GEOPRISMA_LIB%\ext-%EXTJS_VERSION%
set EXTJS_SRC=%SRC_LIB%\ext-%EXTJS_VERSION%
IF NOT EXIST "%EXTJS_DST%" mkdir "%EXTJS_DST%"
IF NOT EXIST "%EXTJS_DST%\resources" mkdir "%EXTJS_DST%\resources"

xcopy "%EXTJS_SRC%\resources\images" "%EXTJS_DST%\resources\images\" /S /Q
xcopy "%EXTJS_SRC%\resources\css\ext-all.css" "%EXTJS_DST%\resources\css\" /Q
xcopy "%EXTJS_SRC%\ext-all.js" "%EXTJS_DST%\" /Q
xcopy "%EXTJS_SRC%\adapter\ext\ext-base.js" "%EXTJS_DST%\adapter\ext\" /Q
xcopy "%EXTJS_SRC%\src\locale" "%EXTJS_DST%\src\locale\" /Q

rem ----------------------------------
rem borealis lib
rem ----------------------------------

echo.
echo *************************
echo ** Release - Other lib **
echo *************************

xcopy "%SRC_LIB%\php-borealis-foundation-0.1.0.19-lite" "%RELEASE_GEOPRISMA_LIB%\php-borealis-foundation-0.1.0.19-lite\" /S /Q
xcopy "%SRC_LIB%\php-borealis-acl-0.1.0.9-lite" "%RELEASE_GEOPRISMA_LIB%\php-borealis-acl-0.1.0.9-lite\" /S /Q
xcopy "%SRC_LIB%\php-borealis-authentication-0.1.0.2-lite" "%RELEASE_GEOPRISMA_LIB%\php-borealis-authentication-0.1.0.2-lite\" /S /Q
xcopy "%SRC_LIB%\php-borealis-users-0.1.0.1-lite" "%RELEASE_GEOPRISMA_LIB%\php-borealis-users-0.1.0.1-lite\" /S /Q
xcopy "%SRC_LIB%\Smarty-2.6.22\libs" "%RELEASE_GEOPRISMA_LIB%\Smarty-2.6.22\libs\" /S /Q


echo.
echo ********************
echo ** Config samples **
echo ********************

del /F /Q  "%RELEASE_GEOPRISMA_SAMPLES%\config.php"

sed -e s/externals\/mapfish-client-trunk\/mfbase\/mapfish/mapfish-r%MAPFISH_REV%/ ^
    -e s/externals\/mapfish-client-trunk\/mfbase\/openlayers/openlayers-r%OPENLAYERS_REV%/ ^
    -e s/externals\/mapfish-client-trunk\/mfbase\/geoext/geoext-r%GEOEXT_REV%/ ^
    -e s/$g_strCurrentDir\/../$g_strCurrentDir\/..\/lib\/geoprisma-%RELEASE_VERSION%/ ^
    -e s/$g_strGeoprisma\/config/$g_strCurrentDir\/..\/config/ ^
    -e s/$g_strGeoprisma\/lib/$g_strCurrentDir\/..\/lib/ ^
    -e s/$g_strUrlPrefix\/src/$g_strUrlPrefix\/lib\/geoprisma-%RELEASE_VERSION%\/src/ ^
    "../samples/config.php" > "%RELEASE_GEOPRISMA_SAMPLES%\config.php"

echo.
echo ********
echo ** 7z **
echo ********
7z a -mx9 -t7z "%RELEASE_DIR%.7z" "%RELEASE_DIR%"
7z a -mx9 -tzip "%RELEASE_DIR%.zip" "%RELEASE_DIR%"
