<?php

header('Content-type: application/json; charset=UTF-8');  


// --------------------------------------
// Set include path
// --------------------------------------
set_include_path(".".PATH_SEPARATOR.'../../../../lib/php-borealis-foundation-0.1.0.19-lite');
                     
// --------------------------------------
// Require class
// --------------------------------------
require_once 'com/borealis/Autoload.php';  
  
$strCurrentDir = dirname(__FILE__);  

$strTarget = com_borealis_foundation_util_Path::getAbsolute("$strCurrentDir/../../../../dist"); 



$g_objArrayError = array();

if(file_exists("$strTarget/junit_result.xml"))
{
    try
    {
        $objSimpleXMLElement = @simplexml_load_file("$strTarget/junit_result.xml"); 

        if ($objSimpleXMLElement != null)
        {
            $objSimpleXMLElementTests = $objSimpleXMLElement->xpath('//testcase');   

            $iID = -1;
            foreach($objSimpleXMLElementTests as $objSimpleXMLElementTest)     
            {
                $objSimpleXMLElementErrors = $objSimpleXMLElementTest->xpath('./error');
                foreach($objSimpleXMLElementErrors as $objSimpleXMLElementError)
                {
                    array_push($g_objArrayError, array( 'id' => ++$iID,
                                                        'severity' => 'error',
                                                        'message' => (string)$objSimpleXMLElementError['message'],
                                                        'test' => (string)$objSimpleXMLElementTest['name'],
                                                        'classname' => (string)$objSimpleXMLElementTest['classname'] ));     
                }
                
                $objSimpleXMLElementFailures = $objSimpleXMLElementTest->xpath('./failure');
                foreach($objSimpleXMLElementFailures as $objSimpleXMLElementFailure)
                {
                    array_push($g_objArrayError, array( 'id' => ++$iID,
                                                        'severity' => 'failure',
                                                        'message' => (string)$objSimpleXMLElementFailure['message'],
                                                        'test' => (string)$objSimpleXMLElementTest['name'],
                                                        'classname' => (string)$objSimpleXMLElementTest['classname'] ));     
                }            
            }
        }
    }
    catch(Exception $e)
    {
        // Ne rien faire
    }
}
echo json_encode( array("tests" => $g_objArrayError));

?>