<?php
  
// --------------------------------------
// Set include path
// --------------------------------------
set_include_path(".".PATH_SEPARATOR.'../../../../lib/php-borealis-foundation-0.1.0.19-lite'.
                     PATH_SEPARATOR.'../../../../lib/php-borealis-acl-0.1.0.9-lite'. 
                     PATH_SEPARATOR.'../../../../lib/PHPUnit-3.3.9'.
                     PATH_SEPARATOR.'../../../../src/server/core'.
                     PATH_SEPARATOR.'../../../../test/phpunit/server/core');
                     
// --------------------------------------
// Require class
// --------------------------------------
require_once 'com/borealis/Autoload.php';  
 
ob_start();
  
$strCurrentDir = dirname(__FILE__);  

$strTarget = com_borealis_foundation_util_Path::getAbsolute("$strCurrentDir/../../../../dist"); 
$strConfiguration = com_borealis_foundation_util_Path::getAbsolute("$strCurrentDir/PhpUnit.xml");  
$strSource = com_borealis_foundation_util_Path::getAbsolute("$strCurrentDir/../../../../test/phpunit");
$strFilter = com_borealis_foundation_util_Path::getAbsolute("$strCurrentDir/../../../../src");  

$strConfig = '<?xml version="1.0" encoding="utf-8"?>
<phpunit stopOnFailure="false">
    <testsuite name="Geoprisma test">
        <directory>'.$strSource.'</directory>
    </testsuite>
    <logging>
        <log type="coverage-html" target="'.$strTarget.'/coverage" charset="iso-8859-1" yui="true" highlight="false" lowUpperBound="90" highLowerBound="100"/>
        <log type="coverage-xml"  target="'.$strTarget.'/coverage/clover.xml"/>        
        <log type="junit"         target="'.$strTarget.'/junit_result.xml" />
    </logging> 
    <filter>
        <whitelist>
            <directory suffix=".php">'.$strFilter.'</directory>
        </whitelist>
    </filter>
</phpunit>';
file_put_contents('PhpUnit.xml', $strConfig);  

$_SERVER['argv'] = array(
                        'Command.php',
                        '--no-syntax-check',
                        '--bootstrap','org/geoprisma/Bootstrap.php',
                        
                        '--configuration',$strConfiguration);

$_SERVER['argc'] = count($_SERVER['argv']);

if (!file_exists($strTarget))
{
    mkdir($strTarget, 0777, true);     
}

if (!file_exists("$strTarget/coverage"))
{
    mkdir("$strTarget/coverage", 0777, true);     
}

require_once 'PHPUnit/TextUI/Command.php'; 
?>