<?php
  
// --------------------------------------
// Set include path
// --------------------------------------
set_include_path(".".PATH_SEPARATOR.'../../../../lib/php-borealis-foundation-0.1.0.19-lite'.
                     PATH_SEPARATOR.'../../../../lib/PEAR-1.7.2'.
                     PATH_SEPARATOR.'../../../../lib/PHP_CodeSniffer-1.2.0a1');
                     
// --------------------------------------
// Require class
// --------------------------------------
require_once 'com/borealis/Autoload.php';  
require_once 'CodeSniffer/CLI.php'; 
  
$strCurrentDir = dirname(__FILE__);  

$strTarget = com_borealis_foundation_util_Path::getAbsolute("$strCurrentDir/../../../../dist"); 
$strSource = com_borealis_foundation_util_Path::getAbsolute("$strCurrentDir/../../../../src/server/core");

$_SERVER['argv'] = array(
                        'phpcs',
                        '--ignore=%%*.tpl.php',
                        '--standard=OpenSafeMap',
                        "--report=checkstyle",    
                        "--report-file=$strTarget/sniffer_result.xml",
                        "$strSource");

$_SERVER['argc'] = count($_SERVER['argv']);

if (!file_exists($strTarget))
{
    mkdir($strTarget, 0777, true);     
}

ob_start();

$phpcs = new PHP_CodeSniffer_CLI();
$phpcs->checkRequirements();

$iErrorsNumber = $phpcs->process(); 

ob_end_clean();


$objSimpleXMLElement = simplexml_load_file("$strTarget/sniffer_result.xml");

$iWarningsNumber = count($objSimpleXMLElement->xpath('//error[@severity = "warning"]'));
   
echo 'Error: '.($iErrorsNumber - $iWarningsNumber).' Warning: '.$iWarningsNumber; 
?>