<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:exslt="http://exslt.org/common"
    xmlns:quickzoom="http://geoprisma.org/quickzoom"
    xmlns:zoomslider="http://geoprisma.org/zoomslider"
    xmlns:map="http://geoprisma.org/map"
    xmlns:mapfishlayertree="http://geoprisma.org/mapfishlayertree"
    xmlns:mapfishrecenter="http://geoprisma.org/mapfishrecenter"
    xmlns:measuretool="http://geoprisma.org/measuretool"
    xmlns:toolbar="http://geoprisma.org/toolbar"
    xmlns:queryonclick="http://geoprisma.org/queryonclick"
    xmlns:popup="http://geoprisma.org/popup"
    xmlns:resultextgrid="http://geoprisma.org/resultextgrid"
    xmlns:delegatefeature="http://geoprisma.org/delegatefeature"
    xmlns:initialview="http://geoprisma.org/initialview"
    xmlns:mouseposition="http://geoprisma.org/mouseposition"
    xmlns:getmouseposition="http://geoprisma.org/getmouseposition"
    xmlns:scale="http://geoprisma.org/scale"
    xmlns:editfeature_create="http://geoprisma.org/editfeature_create"
    xmlns:editfeature_update="http://geoprisma.org/editfeature_update"
    xmlns:editfeature_delete="http://geoprisma.org/editfeature_delete"
    xmlns:featurepanel_form="http://geoprisma.org/featurepanel_form"
    xmlns:featurepanel_selector="http://geoprisma.org/featurepanel_selector"
    xmlns:legendpanel="http://geoprisma.org/legendpanel"
    xmlns:geoexttoolbar="http://geoprisma.org/geoexttoolbar"
    xmlns:merge="http://geoprisma.org/merge"
    xmlns:split="http://geoprisma.org/split"
    xmlns:shortcut="http://geoprisma.org/shortcut"
    xmlns:geoextux_geonamessearchcombo="http://geoprisma.org/geoextux_geonamessearchcombo"
    xmlns:geoextux_redliningpanel="http://geoprisma.org/geoextux_redliningpanel"
    xmlns:pdfprint="http://geoprisma.org/pdfprint"
    xmlns:wmslayeradder="http://geoprisma.org/wmslayeradder"
    xmlns:geoextux_shortcutcombo="http://geoprisma.org/geoextux_shortcutcombo"
    xmlns:geoextux_zoomto="http://geoprisma.org/geoextux_zoomto"
    xmlns:geoextux_wmsbrowser="http://geoprisma.org/geoextux_wmsbrowser"
    xmlns:htwindow="http://geoprisma.org/htwindow"
    xmlns:unselectall="http://geoprisma.org/unselectall"
    xmlns:geoextprintform="http://geoprisma.org/geoextprintform"
    xmlns:filetreepanel="http://geoprisma.org/filetreepanel"
    xmlns:geoextux_layertreebuilder="http://geoprisma.org/geoextux_layertreebuilder"
    xmlns:mappanel="http://geoprisma.org/mappanel"
    xmlns:layer="http://geoprisma.org/layer"
    xmlns:querybyrect="http://geoprisma.org/querybyrect"
    xmlns:featurepanel_attributeform="http://geoprisma.org/featurepanel_attributeform"
    xmlns:featurepanel_customform="http://geoprisma.org/featurepanel_customform"
    xmlns:vectorlayer="http://geoprisma.org/vectorlayer"
    xmlns:resultvectorlayer="http://geoprisma.org/resultvectorlayer"
    xmlns:queryonclickwizard="http://geoprisma.org/queryonclickwizard"
    xmlns:attributefilterpanel="http://geoprisma.org/attributefilterpanel"
    xmlns:wfsfilterbuilder="http://geoprisma.org/wfsfilterbuilder"
    xmlns:geoextux_printpreview="http://geoprisma.org/geoextux_printpreview"
    xmlns:templatepopup="http://geoprisma.org/templatepopup"
    xmlns:toggle="http://geoprisma.org/toggle"
    xmlns:editfeature_split="http://geoprisma.org/editfeature_split"
    xmlns:editfeature_drag="http://geoprisma.org/editfeature_drag"
    xmlns:editfeature_copy="http://geoprisma.org/editfeature_copy"
    xmlns:editfeature_confirm="http://geoprisma.org/editfeature_confirm"
    xmlns:keepactivesession="http://geoprisma.org/keepactivesession"
    xmlns:api="http://geoprisma.org/api"
    xmlns:applyfilter="http://geoprisma.org/applyfilter"
    
    extension-element-prefixes="dyn exslt quickzoom zoomslider map mapfishlayertree mapfishrecenter toolbar queryonclick popup resultextgrid delegatefeature initialview mouseposition getmouseposition scale editfeature_create editfeature_update editfeature_delete featurepanel_form legendpanel geoexttoolbar merge split shortcut featurepanel_selector geoextux_geonamessearchcombo geoextux_redliningpanel pdfprint wmslayeradder geoextux_shortcutcombo geoextux_zoomto geoextux_wmsbrowser htwindow unselectall geoextprintform filetreepanel geoextux_layertreebuilder mappanel layer querybyrect featurepanel_attributeform featurepanel_customform vectorlayer resultvectorlayer queryonclickwizard attributefilterpanel geoextux_printpreview wfsfilterbuilder templatepopup toggle editfeature_split editfeature_drag editfeature_copy editfeature_confirm keepactivesession api applyfilter">

    <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
    <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

    <!-- 
     Function : getWidgetAccess
     Check if the role has access to the widget with a given action

     Returns: true/false
 #### TODO returns the access instead of true
-->

    <xsl:template name="getWidgetAccess">
        <xsl:param name="pWidgetName" />
        <xsl:param name="pWidgetAction" />

        <!--xsl:choose>
      <xsl:when test="php:functionString('test', $pWidgetName, $pWidgetAction)='true'">
        <xsl:value-of select="true"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="false"/>
      </xsl:otherwise>
    </xsl:choose-->
        <xsl:text>true</xsl:text>

    </xsl:template>


    <!--
    Function: printAllWidgetSources

    Browse each widget in resources.  For each widget found, verify if we have
    access and its dependencies.  Then, if it's the first type of widget to be
    printed, add it to the php array of widgets and print its source code.
    
   
-->
    <xsl:template name="printAllWidgetSources">

      <!-- API Widget Source, added first and always added, thus isn't required
           to be included in config 
        -->
      <xsl:call-template name="api:printWidgetSource" />

        <xsl:for-each select="/geoprisma/widgettypesused/widget">
            <xsl:variable name="WidgetType">
                <xsl:value-of select="."/>
            </xsl:variable>

            <xsl:choose>
                <xsl:when test="$WidgetType='quickzoom'">
                    <xsl:call-template name="quickzoom:printWidgetSource" />
                </xsl:when>
                <xsl:when test="$WidgetType='map'">
                    <xsl:call-template name="map:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='mapfishlayertree'">
                    <xsl:call-template name="mapfishlayertree:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='mapfishrecenter'">
                    <xsl:call-template name="mapfishrecenter:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='measuretool'">
                    <xsl:call-template name="measuretool:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='getmouseposition'">
                    <xsl:call-template name="getmouseposition:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='toolbar'">
                    <xsl:call-template name="toolbar:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='queryonclick'">
                    <xsl:call-template name="queryonclick:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='popup'">
                    <xsl:call-template name="popup:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='resultextgrid'">
                    <xsl:call-template name="resultextgrid:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='delegatefeature'">
                    <xsl:call-template name="delegatefeature:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='initialview'">
                    <xsl:call-template name="initialview:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='zoomslider'">
                    <xsl:call-template name="zoomslider:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_create'">
                  <xsl:call-template name="editfeature_create:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_update'">
                  <xsl:call-template name="editfeature_update:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_delete'">
                  <xsl:call-template name="editfeature_delete:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='featurepanel_form'">
                  <xsl:call-template name="featurepanel_form:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='featurepanel_selector'">
                  <xsl:call-template name="featurepanel_selector:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='legendpanel'">
                  <xsl:call-template name="legendpanel:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='geoexttoolbar'">
                  <xsl:call-template name="geoexttoolbar:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='merge'">
                  <xsl:call-template name="merge:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='split'">
                  <xsl:call-template name="split:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='shortcut'">
                  <xsl:call-template name="shortcut:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_geonamessearchcombo'">
                  <xsl:call-template name="geoextux_geonamessearchcombo:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_redliningpanel'">
                  <xsl:call-template name="geoextux_redliningpanel:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='pdfprint'">
                  <xsl:call-template name="pdfprint:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='wmslayeradder'">
                  <xsl:call-template name="wmslayeradder:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_shortcutcombo'">
                  <xsl:call-template name="geoextux_shortcutcombo:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_zoomto'">
                  <xsl:call-template name="geoextux_zoomto:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_wmsbrowser'">
                  <xsl:call-template name="geoextux_wmsbrowser:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='htwindow'">
                  <xsl:call-template name="htwindow:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='unselectall'">
                  <xsl:call-template name="unselectall:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextprintform'">
                  <xsl:call-template name="geoextprintform:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='filetreepanel'">
                  <xsl:call-template name="filetreepanel:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_layertreebuilder'">
                  <xsl:call-template name="geoextux_layertreebuilder:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='mappanel'">
                  <xsl:call-template name="mappanel:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='layer'">
                  <xsl:call-template name="layer:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='querybyrect'">
                    <xsl:call-template name="querybyrect:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='featurepanel_attributeform'">
                    <xsl:call-template name="featurepanel_attributeform:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='featurepanel_customform'">
                    <xsl:call-template name="featurepanel_customform:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='vectorlayer'">
                    <xsl:call-template name="vectorlayer:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='resultvectorlayer'">
                    <xsl:call-template name="resultvectorlayer:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='queryonclickwizard'">
                    <xsl:call-template name="queryonclickwizard:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='attributefilterpanel'">
                  <xsl:call-template name="attributefilterpanel:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='wfsfilterbuilder'">
                  <xsl:call-template name="wfsfilterbuilder:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_printpreview'">
                  <xsl:call-template name="geoextux_printpreview:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='templatepopup'">
                  <xsl:call-template name="templatepopup:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='toggle'">
                  <xsl:call-template name="toggle:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_split'">
                  <xsl:call-template name="editfeature_split:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_drag'">
                  <xsl:call-template name="editfeature_drag:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_copy'">
                  <xsl:call-template name="editfeature_copy:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_confirm'">
                  <xsl:call-template name="editfeature_confirm:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='keepactivesession'">
                  <xsl:call-template name="keepactivesession:printWidgetSource"/>
                </xsl:when>
                <xsl:when test="$WidgetType='applyfilter'">
                  <xsl:call-template name="applyfilter:printWidgetSource"/>
                </xsl:when>
            </xsl:choose>
        </xsl:for-each>
    </xsl:template>


    <!--
    Function: printAllWidgetExecutions

    For each widget in the php array, print its execution code.
-->
    <xsl:template name="printAllWidgetExecutions">
        <xsl:param name="pMapName" />

        <!-- API Widget Execution, always done first -->
        <xsl:call-template name="api:printWidgetExecution">
          <!--xsl:with-param name="pWidgetName" select="$WidgetName" /-->
          <xsl:with-param name="pMapName" select="$pMapName" />
        </xsl:call-template>
        
        <xsl:for-each select="/geoprisma/widgets/widget">
            <xsl:variable name="WidgetType">
                <xsl:value-of select="./type"/>
            </xsl:variable>
            <xsl:variable name="WidgetName">
                <xsl:value-of select="./name"/>
            </xsl:variable>

            <xsl:choose>
                <xsl:when test="$WidgetType='quickzoom'">
                    <xsl:call-template name="quickzoom:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='map'">
                    <xsl:call-template name="map:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='mapfishlayertree'">
                    <xsl:call-template name="mapfishlayertree:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='mapfishrecenter'">
                    <xsl:call-template name="mapfishrecenter:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='measuretool'">
                    <xsl:call-template name="measuretool:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='toolbar'">
                    <xsl:call-template name="toolbar:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='queryonclick'">
                    <xsl:call-template name="queryonclick:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='popup'">
                    <xsl:call-template name="popup:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='resultextgrid'">
                    <xsl:call-template name="resultextgrid:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='delegatefeature'">
                    <xsl:call-template name="delegatefeature:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>                
                <xsl:when test="$WidgetType='initialview'">
                    <xsl:call-template name="initialview:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='zoomslider'">
                    <xsl:call-template name="zoomslider:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='mouseposition'">
                    <xsl:call-template name="mouseposition:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='getmouseposition'">
                    <xsl:call-template name="getmouseposition:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='scale'">
                    <xsl:call-template name="scale:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>               
                <xsl:when test="$WidgetType='editfeature_create'">
                    <xsl:call-template name="editfeature_create:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_update'">
                    <xsl:call-template name="editfeature_update:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_delete'">
                    <xsl:call-template name="editfeature_delete:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='featurepanel_form'">
                    <xsl:call-template name="featurepanel_form:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='featurepanel_selector'">
                    <xsl:call-template name="featurepanel_selector:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='legendpanel'">
                    <xsl:call-template name="legendpanel:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='geoexttoolbar'">
                    <xsl:call-template name="geoexttoolbar:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='merge'">
                    <xsl:call-template name="merge:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>             
                <xsl:when test="$WidgetType='split'">
                    <xsl:call-template name="split:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='shortcut'">
                    <xsl:call-template name="shortcut:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_geonamessearchcombo'">
                    <xsl:call-template name="geoextux_geonamessearchcombo:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_redliningpanel'">
                  <xsl:call-template name="geoextux_redliningpanel:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='pdfprint'">
                  <xsl:call-template name="pdfprint:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='wmslayeradder'">
                  <xsl:call-template name="wmslayeradder:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_shortcutcombo'">
                  <xsl:call-template name="geoextux_shortcutcombo:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_zoomto'">
                  <xsl:call-template name="geoextux_zoomto:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_wmsbrowser'">
                  <xsl:call-template name="geoextux_wmsbrowser:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='htwindow'">
                  <xsl:call-template name="htwindow:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='unselectall'">
                  <xsl:call-template name="unselectall:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextprintform'">
                  <xsl:call-template name="geoextprintform:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='filetreepanel'">
                  <xsl:call-template name="filetreepanel:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_layertreebuilder'">
                  <xsl:call-template name="geoextux_layertreebuilder:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='mappanel'">
                  <xsl:call-template name="mappanel:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='layer'">
                  <xsl:call-template name="layer:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='querybyrect'">
                  <xsl:call-template name="querybyrect:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='featurepanel_attributeform'">
                  <xsl:call-template name="featurepanel_attributeform:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='featurepanel_customform'">
                  <xsl:call-template name="featurepanel_customform:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='vectorlayer'">
                  <xsl:call-template name="vectorlayer:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='resultvectorlayer'">
                  <xsl:call-template name="resultvectorlayer:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='queryonclickwizard'">
                  <xsl:call-template name="queryonclickwizard:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='attributefilterpanel'">
                  <xsl:call-template name="attributefilterpanel:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='wfsfilterbuilder'">
                  <xsl:call-template name="wfsfilterbuilder:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='geoextux_printpreview'">
                  <xsl:call-template name="geoextux_printpreview:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='templatepopup'">
                  <xsl:call-template name="templatepopup:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='toggle'">
                  <xsl:call-template name="toggle:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_split'">
                  <xsl:call-template name="editfeature_split:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_drag'">
                  <xsl:call-template name="editfeature_drag:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_copy'">
                  <xsl:call-template name="editfeature_copy:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='editfeature_confirm'">
                  <xsl:call-template name="editfeature_confirm:printWidgetExecution">
                    <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='keepactivesession'">
                    <xsl:call-template name="keepactivesession:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:when test="$WidgetType='applyfilter'">
                    <xsl:call-template name="applyfilter:printWidgetExecution">
                        <xsl:with-param name="pWidgetName" select="$WidgetName" />
                        <xsl:with-param name="pMapName" select="$pMapName" />
                    </xsl:call-template>
                </xsl:when>

            </xsl:choose>
        </xsl:for-each>
        
        <xsl:for-each select="/geoprisma/widgets/widget[./name = $pMapName]">
          <script type="text/javascript">
            objGPWidget<xsl:value-of select="$pMapName" />.events.triggerEvent("printallwidgetexecutions", {});
          </script>
        </xsl:for-each>

    </xsl:template>

    <!--
        Function: printAllLibSources
        The purpose of this method is to includes client libraries required by
        GeoPrisma and its widgets. It also support i18n (see below for the list
        of supported 'locale' settings.

        Libraries it loads : 
          * OpenLayers
          * GeoExt
          * MapFish

       :param pVersion: (String) Defaults to 'stable'.  Possible values are :
                        'stable', 'unstable' and 'deprecated'.  Determines the
                        libraries to load depending on the widgets used.
       :param pCompressed: (Boolean) Defaults to 'true'. Whether to load the
                           libraries compressed or uncompressed (for debug 
                           purpose).

       Note : other minor libraries (for example : ux) are already automatically
              loaded by the printWidgetSource widget method (uncompressed only).
      -->
    <xsl:template name="printAllLibSources">
      <xsl:param name="pVersion" />
      <xsl:param name="pCompressed" />

      <xsl:variable name="libVersion">
        <xsl:choose>
          <xsl:when test="$pVersion = 'unstable'">unstable</xsl:when>
          <xsl:when test="$pVersion = 'deprecated'">deprecated</xsl:when>
          <xsl:otherwise>stable</xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <xsl:variable name="libCompressed">
        <xsl:choose>
          <xsl:when test="$pCompressed = '1'">true</xsl:when>
          <xsl:when test="$pCompressed = 'true'">true</xsl:when>
          <xsl:when test="$pCompressed = 'false'">false</xsl:when>
          <xsl:when test="$pCompressed = ''">false</xsl:when>
          <xsl:otherwise>true</xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <!-- include libraries START -->
      <xsl:choose>
        <!-- compressed libraries -->
        <xsl:when test="$libCompressed = 'true'">
          <xsl:choose>

            <!-- deprecated : MapFish+GeoExt+OpenLayers START -->
            <xsl:when test="$libVersion = 'deprecated'">
              <link rel="stylesheet" type="text/css">
                <xsl:attribute name="href" >
                  <xsl:value-of select="$g_lib_url"/>
                  <xsl:text>/mapfish-build/openlayers/theme/default/style.css</xsl:text>
                </xsl:attribute>
              </link>

              <link rel="stylesheet" type="text/css">
                <xsl:attribute name="href" >
                  <xsl:value-of select="$g_lib_url"/>
                  <xsl:text>/mapfish-build/mapfish/mapfish.css</xsl:text>
                </xsl:attribute>
              </link>

              <script type="text/javascript">
                <xsl:attribute name="src" >
                  <xsl:value-of select="$g_lib_url"/>
                  <xsl:text>/mapfish-build/mapfish/MapFish.js</xsl:text>
                </xsl:attribute>
              </script>

              <script type="text/javascript">
                OpenLayers.ImgPath = "<xsl:value-of select="$g_lib_url"/>/mapfish-build/openlayers/img/";
                var gMfLocation = "<xsl:value-of select="$g_lib_url"/>/mapfish-build/mapfish/";
                var map;
              </script>
            </xsl:when>
            <!-- deprecated : MapFish+GeoExt+OpenLayers END -->

            <!-- stable, unstable : OpenLayers, GeoExt START-->
            <xsl:otherwise>
              <link rel="stylesheet" type="text/css">
                <xsl:attribute name="href" >
                  <xsl:value-of select="$g_lib_url"/>
                  <xsl:text>/openlayers/theme/default/style.css</xsl:text>
                </xsl:attribute>
              </link>

              <script type="text/javascript">
                <xsl:attribute name="src" >
                  <xsl:value-of select="$g_lib_url"/>
                  <xsl:text>/openlayers/OpenLayers.js</xsl:text>
                </xsl:attribute>
              </script>

              <script type="text/javascript">
                OpenLayers.ImgPath = "<xsl:value-of select="$g_lib_url"/>/openlayers/img/";
              </script>

              <script type="text/javascript">
                <xsl:attribute name="src" >
                  <xsl:value-of select="$g_lib_url"/>
                  <xsl:text>/geoext/script/GeoExt.js</xsl:text>
                </xsl:attribute>
              </script>
            </xsl:otherwise>
            <!-- stable, unstable : OpenLayers, GeoExt END-->

          </xsl:choose>

        </xsl:when>
        
        <!-- uncompressed libraries -->
        <xsl:otherwise>
          <!-- OpenLayers : stable, unstable, deprecated -->
          <link rel="stylesheet" type="text/css">
            <xsl:attribute name="href" >
              <xsl:value-of select="$g_lib_url"/>
              <xsl:text>/openlayers/theme/default/style.css</xsl:text>
            </xsl:attribute>
          </link>

          <script type="text/javascript">
            <xsl:attribute name="src" >
              <xsl:value-of select="$g_lib_url"/>
              <xsl:text>/openlayers/lib/OpenLayers.js</xsl:text>
            </xsl:attribute>
          </script>

          <script type="text/javascript">
            OpenLayers.ImgPath = "<xsl:value-of select="$g_lib_url"/>/openlayers/img/";
          </script>

          <!-- GeoExt : stable, unstable, deprecated -->
          <script type="text/javascript">
            <xsl:attribute name="src" >
              <xsl:value-of select="$g_lib_url"/>
              <xsl:text>/geoext/lib/GeoExt.js</xsl:text>
            </xsl:attribute>
          </script>

          <!-- MapFish : deprecated -->
          <xsl:if test="$libVersion = 'deprecated'">
            <script type="text/javascript">
              <xsl:attribute name="src" >
                <xsl:value-of select="$g_lib_url"/>
                <xsl:text>/mapfish/MapFish.js</xsl:text>
              </xsl:attribute>
            </script>
            <script type="text/javascript">
              var gMfLocation = "<xsl:value-of select="$g_lib_url"/>/mapfish/";
              var map;
            </script>
          </xsl:if>

        </xsl:otherwise>
      </xsl:choose>
      <!-- include libraries END -->

      <!-- i18n (locale) START -->
      <xsl:choose>

        <!-- fr_CA -->
        <xsl:when test="$g_locale = 'fr_CA'">
          <!-- source for OpenLayers and GeoExt -->
          <script type="text/javascript">
            <xsl:attribute name="src" >
              <xsl:value-of select="$g_lib_url"/>
              <xsl:text>/openlayers/lib/OpenLayers/Lang/fr.js</xsl:text>
            </xsl:attribute>
          </script>
          <script type="text/javascript">
            <xsl:attribute name="src" >
              <xsl:value-of select="$g_lib_url"/>
              <xsl:text>/geoext/lib/GeoExt/locale/GeoExt-fr.js</xsl:text>
            </xsl:attribute>
          </script>
          <!-- source for MapFish (deprecated), sets OpenLayers.Lang -->
          <xsl:if test="$libVersion = 'deprecated'">
            <script type="text/javascript">
              <xsl:attribute name="src" >
                <xsl:value-of select="$g_lib_url"/>
                <xsl:text>/mapfish/lang/fr.js</xsl:text>
              </xsl:attribute>
            </script>
          </xsl:if>
          <script type="text/javascript">
            OpenLayers.Lang.setCode("fr");
            GeoExt.Lang.set("fr");
          </script>
        </xsl:when>

        <!-- en_US (defaults in all libraries, no need to load anything) -->
        <xsl:otherwise />

      </xsl:choose>
      <!-- i18n (locale) END -->

      <!-- call printAllGYMOSources -->
      <xsl:call-template name="printAllGYMOSources" />

    </xsl:template>

    <!--
        Function: printAllGYMOSources
        The purpose of this method is to include the following external
        libraries when the according service is set :

        * Google (v3+ only, v2 not supported)
        * Bing (currently not supported)
        * Yahoo

        They are only loaded when the service is set.  It is automatically
        called at the end of printAllLibSources.

        Note : All service of 'gymo' type are browsed and include the according
        source it requires, so make sure to define only one of each type in
        your configuration.
      -->
    <xsl:template name="printAllGYMOSources">
      <xsl:for-each select="/geoprisma/services/service[./type = 'gymo']">
        <xsl:choose>
          <!-- Google -->
          <xsl:when test="./provider = 'google'">
            <script type="text/javascript">
              <xsl:attribute name="src" >
                <xsl:value-of select="./source" />
                <!-- apikey -->
                <xsl:if test="./apikey">
                  <xsl:text>&amp;key=</xsl:text>
                  <xsl:value-of select="./apikey" />
                </xsl:if>
                <!-- i18n -->
                <xsl:choose>
                  <xsl:when test="$g_locale = 'fr_CA'">
                    <xsl:text>&amp;hl=fr</xsl:text>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:text>&amp;hl=en</xsl:text>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </script> 
          </xsl:when>
          <!-- Bing, currently not supported -->
          <xsl:when test="./provider = 'bing'" />
          <!-- Yahoo -->
          <xsl:when test="./provider = 'yahoo'">
            <script type="text/javascript">
              <xsl:attribute name="src" >
                <xsl:value-of select="./source" />
              </xsl:attribute>
            </script> 
          </xsl:when>
        </xsl:choose>
      </xsl:for-each>
    </xsl:template>
    <!-- printAllGYMOSources END -->
    
    <!--  
  This function returns the value of a specific widget option
  -->
    <xsl:template name="getWidgetOptionByName">
        <xsl:param name="pWidgetName" />
        <xsl:param name="pOptionName" />

        <xsl:variable name="XPathExpression">
            <xsl:text>//geoprisma/widgets/widget[./name[.='</xsl:text>
            <xsl:value-of select="$pWidgetName"/>
            <xsl:text>']]</xsl:text>
            <xsl:text>/options/</xsl:text>
            <xsl:value-of select="$pOptionName"/>
        </xsl:variable>

        <xsl:value-of select="dyn:evaluate($XPathExpression)"/>
    </xsl:template>

    <!--  
    This function returns the type of a widget given its name
    -->
    <xsl:template name="getWidgetTypeByName">
        <xsl:param name="pWidgetName" />

        <xsl:variable name="XPathExpression">
            <xsl:text>//geoprisma/widgets/widget[./name[.='</xsl:text>
            <xsl:value-of select="$pWidgetName"/>
            <xsl:text>']]</xsl:text>
            <xsl:text>/type</xsl:text>
        </xsl:variable>

        <xsl:value-of select="dyn:evaluate($XPathExpression)"/>
    </xsl:template>

    <!--
    function : getDataStoreInfoFromWidget
               ...

    parameters :
        pWidgetName - ...
        pServiceType - ...
        pNodeName - ...
        pResourceName - ...

    returns : 
        outputs ...
    -->
    <xsl:template name="getDataStoreInfoFromWidget">
        <xsl:param name="pWidgetName" />
        <xsl:param name="pServiceType" />
        <xsl:param name="pNodeName" />
        <xsl:param name="pResourceName" />

        <xsl:variable name="XPathDataStoreName">
            <xsl:text>/geoprisma/widgets/widget[./name='</xsl:text>
            <xsl:value-of select="$pWidgetName"/>
            <xsl:text>']/datastores/datastore[./resourcename='</xsl:text>
            <xsl:value-of select="$pResourceName"/>
            <xsl:text>']/datastorename[../servicename=/geoprisma/services/service[./type='</xsl:text>
            <xsl:value-of select="$pServiceType"/>
            <xsl:text>']/name]</xsl:text>
        </xsl:variable>

      <xsl:variable name="sReturnValue">
        <xsl:for-each select="dyn:evaluate($XPathDataStoreName)">
            <xsl:variable name="DataStoreName" select="." />

            <xsl:variable name="XPathDataStoreNodeValueReturn">
                <xsl:text>/geoprisma/datastores/datastore[./name='</xsl:text>
                <xsl:value-of select="$DataStoreName"/>
                <xsl:text>']/</xsl:text>
                <xsl:value-of select="$pNodeName" />
            </xsl:variable>
            <xsl:choose>
                <xsl:when test="$pNodeName = 'params/text'">
                    <xsl:for-each select="dyn:evaluate($XPathDataStoreNodeValueReturn)" ><xsl:call-template name="getText" /></xsl:for-each> 
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="dyn:evaluate($XPathDataStoreNodeValueReturn)" />   
                </xsl:otherwise>
            </xsl:choose>            
        </xsl:for-each>
      </xsl:variable>
      
      <xsl:value-of select="$sReturnValue"/>

    </xsl:template>

    <!--
    function : getDataStoreInfoFromResource
               Same as getDataStoreInfoFromWidget, except that it uses the
               native geoprisma resources instead of those in a widget

    parameters :
        pServiceType - (String) The type of the service
        pNodeName - (String) The datastore node info we're looking for
        pResourceName - (String) The name of the resource

    returns : 
        (String) The searched node value if found, else returns blank.
    -->
    <xsl:template name="getDataStoreInfoFromResource">
        <xsl:param name="pServiceType" />
        <xsl:param name="pNodeName" />
        <xsl:param name="pResourceName" />

        <xsl:variable name="XPathDataStoreName">
            <xsl:text>/geoprisma/datastores/datastore[./name=/geoprisma/resources/resource[./name='</xsl:text>
            <xsl:value-of select="$pResourceName"/>
            <xsl:text>']/datastores/datastore][./service=/geoprisma/services/service[./type='</xsl:text>
            <xsl:value-of select="$pServiceType"/>
            <xsl:text>']/name]/name</xsl:text>
        </xsl:variable>

      <xsl:variable name="sReturnValue">
        <xsl:for-each select="dyn:evaluate($XPathDataStoreName)">
            <xsl:variable name="DataStoreName" select="." />

            <xsl:variable name="XPathDataStoreNodeValueReturn">
                <xsl:text>/geoprisma/datastores/datastore[./name='</xsl:text>
                <xsl:value-of select="$DataStoreName"/>
                <xsl:text>']/</xsl:text>
                <xsl:value-of select="$pNodeName" />
            </xsl:variable>
            <xsl:choose>
                <xsl:when test="$pNodeName = 'params/text'">
                    <xsl:for-each select="dyn:evaluate($XPathDataStoreNodeValueReturn)" ><xsl:call-template name="getText" /></xsl:for-each> 
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="dyn:evaluate($XPathDataStoreNodeValueReturn)" />   
                </xsl:otherwise>
            </xsl:choose>            
        </xsl:for-each>
      </xsl:variable>
      
      <xsl:value-of select="$sReturnValue"/>

    </xsl:template>

<!--
    function : getObjectFromNode
               Given a node, build a javascript object or array.

               If the first 2 childs of the node have the same name(), then
               create an array, else create an object using the name of the
               node itself as the 'key' and its value as its value.  If the node
               as childs instead of a value, the function calls itself with the
               child nodes to get the JS of these nodes.

               There's no 'case' support for the "key" properties.  The case
               must be exact.

               Only downside : when looping in the generated object/array, you
               you must use for(key in object) no array is created when having
               only one node.

    parameters :
        pNode - an XML node

    returns : 
        outputs the javascript version of the node.
  -->
    <xsl:template name="getObjectFromNode">
        <xsl:param name="pNode" />
        
        <xsl:variable name="bArray">
            <xsl:choose>
                <xsl:when test="name(*[1]) = name(*[2])">true</xsl:when>
                <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
        </xsl:variable>

        <xsl:choose>
            <xsl:when test="$bArray = 'true'">[</xsl:when>
            <xsl:otherwise>{</xsl:otherwise>
        </xsl:choose>

        <xsl:for-each select='./*'>
            <xsl:if test="position()>1">,</xsl:if>

            <xsl:if test="$bArray = 'false'">
                "<xsl:value-of select='name()'/>": 
            </xsl:if>

            <xsl:choose>
                <xsl:when test="./getValueFrom">
                     <xsl:for-each select='./getValueFrom'><xsl:call-template name="getValueFrom" /></xsl:for-each>           
                </xsl:when>   
                <xsl:when test="./*">
                    <xsl:call-template name="getObjectFromNode">
                        <xsl:with-param name="pNode" select="." />
                    </xsl:call-template>
                </xsl:when>
                <xsl:otherwise>
                    <!-- print the value of the node -->
                    <xsl:call-template name="printNodeValueByType">
                        <xsl:with-param name="pNode" select="." />
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:for-each>

        <xsl:choose>
            <xsl:when test="$bArray = 'true'">]</xsl:when>
            <xsl:otherwise>}</xsl:otherwise>
        </xsl:choose>

    </xsl:template>

<!--
    function : printNodeValueByType
        Given a node, print its value depending on its type.  If the value is
        numeric, outputs the value directly, else outputs with single quotes.

        Example: 
        
        <node>999</node> == will output ==> 999
        <node>foo</node> == will output ==> 'foo'
        <node>true</node> == will output ==> 'true'

    parameters :
        pNode - an XML node

    returns : 
        outputs the value of the node with or without single quotes
  -->
    <xsl:template name="printNodeValueByType">
        <xsl:param name="pNode" />

        <xsl:variable name="isNumeric">
          <xsl:value-of select="number($pNode)" />
        </xsl:variable>

        <xsl:choose>
          <xsl:when test="$pNode = 'true'">
            <xsl:value-of select="$pNode"/>
          </xsl:when>
          <xsl:when test="$pNode = 'false'">
            <xsl:value-of select="$pNode"/>
          </xsl:when>
          <xsl:when test="$isNumeric = 'NaN'">
            <!-- call of org_geoprisma_locale_Locale::getText to encode special char in 'JS' -->
            <xsl:value-of select="php:functionString('org_geoprisma_locale_Locale::getText', string($pNode), 'nodomain', 'JS')" />                    
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$pNode"/>
          </xsl:otherwise>
        </xsl:choose>

    </xsl:template>


<!--
    function : getNumWidgetsByType
        Count and return how many widgets of a given type there is.

    parameters :
        pWidgetType - a widget type

    returns : 
        $XPathExpression - The number of widgets of the given type.
  -->
    <xsl:template name="getNumWidgetsByType">
        <xsl:param name="pWidgetType" />

        <xsl:variable name="XPathExpression">
            <xsl:text>count(/geoprisma/widgets/widget[./type='</xsl:text>
            <xsl:value-of select="$pWidgetType"/>
            <xsl:text>'])</xsl:text>
        </xsl:variable>

        <xsl:value-of select="dyn:evaluate($XPathExpression)" />
    </xsl:template>

<!--
    function : getText
        Reutrn text or is translation
        Before call this template change context to the text node with foreach

    parameters :
        pType - (String) Defaults to 'JS'.  The encoding type.  Can be 'JS' or
                         'HTML'
        
    returns : 
        string - Text to display
  -->
    <xsl:template name="getText">
      <xsl:param name="pType" />

      <xsl:variable name="type">
        <xsl:choose>
          <xsl:when test="$pType = 'JS'">JS</xsl:when>
          <xsl:when test="$pType = 'HTML'">HTML</xsl:when>
          <xsl:otherwise>JS</xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

        <xsl:choose>            
            <xsl:when test="./domain and ./key">
                <xsl:variable name="key">
                     <xsl:value-of select="./key" />  
                </xsl:variable>
                <xsl:variable name="domain">
                     <xsl:value-of select="./domain" />  
                </xsl:variable>
                <xsl:value-of select="php:functionString('org_geoprisma_locale_Locale::getText', string($key), string($domain), $type)" />                    
            </xsl:when>
            <xsl:when test="dyn:evaluate($g_locale)">  
                <xsl:variable name="key">
                     <xsl:value-of select="dyn:evaluate($g_locale)" />  
                </xsl:variable>
                <!-- call of org_geoprisma_locale_Locale::getText to encode special char in $type -->
                <xsl:value-of select="php:functionString('org_geoprisma_locale_Locale::getText', string($key), 'nodomain', $type)" /> 
            </xsl:when>  
            <xsl:otherwise>
                <xsl:variable name="key">
                     <xsl:value-of select="." />  
                </xsl:variable>
                <!-- call of org_geoprisma_locale_Locale::getText to encode special char in $type -->
                <xsl:value-of select="php:functionString('org_geoprisma_locale_Locale::getText', string($key), 'nodomain', $type)" />                    
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template> 
    
    <xsl:template name="getValueFrom">
        <xsl:variable name="source">
             <xsl:value-of select="." />  
        </xsl:variable>
        <xsl:value-of select="php:functionString('org_geoprisma_uirender_UI::getValueFrom', string($source))" />        
    </xsl:template>

    <!-- stringReplaceAll method since replace() doesn't exists with XSLT 1.0
      -->
    <xsl:template name="stringReplaceAll">
      <xsl:param name="text"/>
      <xsl:param name="replace"/>
      <xsl:param name="by"/>
      <xsl:choose>
        <xsl:when test="contains($text,$replace)">
          <xsl:value-of select="substring-before($text,$replace)"/>
          <xsl:value-of select="$by"/>
          <xsl:call-template name="stringReplaceAll">
            <xsl:with-param name="text" select="substring-after($text,$replace)"/>
            <xsl:with-param name="replace" select="$replace"/>
            <xsl:with-param name="by" select="$by"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$text"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:template>

  <!-- getOpenLayersOptions -->
  <xsl:template name="getOpenLayersOptions">
    <xsl:param name="pWidgetName" />
    <xsl:for-each select="/geoprisma/widgets/widget[./name = $pWidgetName]/options">
      var objOptions =
      <xsl:call-template name="getObjectFromNode">
        <xsl:with-param name="pNode" select="." />
      </xsl:call-template>;
      objOptions.strategies = [];

      <xsl:if test="./projectionString">
        objOptions['projection'] = new OpenLayers.Projection("<xsl:value-of select='./projectionString'/>");
      </xsl:if>
      <xsl:if test="./maxExtentString">
        objOptions['maxExtent'] = new OpenLayers.Bounds(<xsl:value-of select='./maxExtentString'/>);
      </xsl:if>
      <xsl:if test="./restrictedExtentString">
        objOptions['restrictedExtent'] = new OpenLayers.Bounds(<xsl:value-of select='./restrictedExtentString'/>);
      </xsl:if>
      <xsl:if test="./tileSizeString">
        objOptions['tileSize'] = new OpenLayers.Size(<xsl:value-of select='./tileSizeString'/>);
      </xsl:if>
      <xsl:if test="./displayProjectionString">
        objOptions['displayProjection'] = new OpenLayers.Projection("<xsl:value-of select='./displayProjectionString'/>");
      </xsl:if>
      <xsl:if test="./resolutionsString">
        objOptions['resolutions'] = [<xsl:value-of select='./resolutionsString'/>];
      </xsl:if>
      <xsl:if test="./scalesString">
        objOptions['scales'] = [<xsl:value-of select='./scalesString'/>];
      </xsl:if>
      <xsl:if test="./cluster">
        objOptions['strategies'].push(new OpenLayers.Strategy.Cluster());
      </xsl:if>

    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
