<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2011- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 

<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:featurepanel_customform="http://geoprisma.org/featurepanel_customform"
    extension-element-prefixes="dyn">
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

<!-- 
     Function : printWidgetSource
-->
  <xsl:template name="featurepanel_customform:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>featurepanel_customform</xsl:text>
    </xsl:variable>

    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/featurepanel/customform/CustomForm.js</xsl:text>
        </xsl:attribute>
    </script>

    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/featurepanel/customform/CustomFormBuilder.js</xsl:text>
        </xsl:attribute>
    </script>

  </xsl:template>

<!-- 
     Function : printWidgetExecution

     Print the execution code for this widget
-->
  <!-- Call for each widget name-->
  <xsl:template name="featurepanel_customform:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="WidgetType">
      <xsl:text>featurepanel_customform</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      Ext.onReady(function() {
          var objWidgetOptions =
          <xsl:for-each select="./options">
            <xsl:call-template name="getObjectFromNode">
              <xsl:with-param name="pNode" select="." />
            </xsl:call-template>
          </xsl:for-each>;

          <!-- Widget object creation  -->
          objGPWidget<xsl:value-of select="$pWidgetName" /> =
              new org.GeoPrisma.FeaturePanel.CustomFormBuilder(objWidgetOptions);

          <xsl:for-each select="./resources/resource">
            <!-- ResourceName -->
            <xsl:variable name="pResourceName">
              <xsl:value-of select="." />
            </xsl:variable>

            if (Ext.isDefined(window.goEditFeatureActions) &amp;&amp;
                goEditFeatureActions['<xsl:value-of select="$pResourceName" />']
            ) {
                Ext.each(goEditFeatureActions['<xsl:value-of select="$pResourceName" />'], function(objEditFeatureAction, index) {
                    if (objEditFeatureAction.control instanceof OpenLayers.Control.EditFeature_Create || objEditFeatureAction.control instanceof OpenLayers.Control.EditFeature_Update) {
                        objEditFeatureAction.control.setFeaturePanel(
                            objGPWidget<xsl:value-of select="$pWidgetName" />
                        );
                    }
                });
            }

          </xsl:for-each><!-- end of for-each resources -->

      }); // onReady end
    </script>
  </xsl:template>

</xsl:stylesheet>
