<?php
/* 
   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. 
*/ 
  
class FeaturePanel_Selector extends org_geoprisma_widget_WidgetBase
{
    static public function getText($pstrMsg, $pstrType = null)
    {
        return parent::getText($pstrMsg, self::getType(), $pstrType);
    }

    static public function getAction()
    {
        return 'read';
    }    
     
    static public function getType()
    {
        return 'featurepanel_selector';
    }

    static public function getServiceType()
    {
        return 'wms';
    }

    static public function getMandatoryResourceOptionList()
    {
        return array(
            "result" => "result",
            "fid" => "primaryField"
        );
    }

    static public function getOptionalResourceOptionList()
    {
        return array(
            "template" => "selectorTemplate",
            "method" => "selectorMethod",
            "height" => "selectorTemplateHeight",
            "width" => "selectorTemplateWidth"
        );
    }

    static public function mustClone()
    {
        return true;
    }

    static public function getMandatoryResourceOptionValueList() 
    {
        return array("result" => "featurepanelselector");
    }

    static public function linkResource($pobjResource, $pobjWidget) 
    {
        if ($pobjResource == null || $pobjWidget == null) 
        {
            return;
        }

        // no need to do anything if resource has no fields
        $objArrayFields = $pobjResource->getFields();
        if (!$objArrayFields || $objArrayFields->count() == 0) 
        {
            return;
        }

        $objArrayFieldNodes = array();

        foreach ($pobjResource->getFields() as $objField) 
        {
            try
            {
                // create new field entry and look for the 'selectType' field
                // option
                $objArrayFieldNode = array('name' => $objField->getName());
                $objOption = $objField->getOption('selectType');

                switch ($objOption->getValue()) 
                {
                    case "keyValue":
                        $objArrayFieldNode['type'] = "key";
                        array_push($objArrayFieldNodes, $objArrayFieldNode);

                        $objArrayFieldNode['type'] = "value";
                        array_push($objArrayFieldNodes, $objArrayFieldNode);

                        break;
                    case "false":
                        break;
                    default:
                        $objArrayFieldNode['type'] = $objOption->getValue();
                        array_push($objArrayFieldNodes, $objArrayFieldNode);
                        break;
                }

            }
            catch(Exception $objError)
            {
            }
        }

        $pobjWidget->addOrReplaceOption(
            new org_geoprisma_option_Option('fields', $objArrayFieldNodes)
        );
    }
}
  
?>
