<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:filetreepanel="http://geoprisma.org/filetreepanel"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="filetreepanel:printWidgetSource">

    <xsl:variable name="WidgetType">
      <xsl:text>filetreepanel</xsl:text>
    </xsl:variable>

    <!-- source files from lib directory -->
    <script type="text/javascript">
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_lib_url"/>
        <xsl:text>/ext/examples/ux/fileuploadfield/FileUploadField.js</xsl:text>
      </xsl:attribute>
    </script>
    <link rel="stylesheet" type="text/css">
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_lib_url"/>
        <xsl:text>/ext/examples/ux/fileuploadfield/css/fileuploadfield.css</xsl:text>
      </xsl:attribute>
    </link>

    <!-- source files from widget directory -->
    <!-- Ext.ux.FileTreePanel source -->
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/Ext.ux.form.BrowseButton.js</xsl:text>
        </xsl:attribute>    
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/Ext.ux.FileUploader.js</xsl:text>
        </xsl:attribute>    
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/Ext.ux.UploadPanel.js</xsl:text>
        </xsl:attribute>    
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/Ext.ux.FileTreeMenu.js</xsl:text>
        </xsl:attribute>    
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/Ext.ux.FileTreePanel.js</xsl:text>
        </xsl:attribute>    
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/Ext.ux.form.IconCombo.js</xsl:text>
        </xsl:attribute>    
    </script>

    <link rel="stylesheet" type="text/css" >
        <xsl:attribute name="href" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/css/icons.css</xsl:text>
        </xsl:attribute>
    </link>
    <link rel="stylesheet" type="text/css" >
        <xsl:attribute name="href" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/css/filetree.css</xsl:text>
        </xsl:attribute>
    </link>
    <link rel="stylesheet" type="text/css" >
        <xsl:attribute name="href" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/css/filetype.css</xsl:text>
        </xsl:attribute>
    </link>
    <link rel="stylesheet" type="text/css" >
        <xsl:attribute name="href" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/css/famflag.css</xsl:text>
        </xsl:attribute>
    </link>
    <link rel="stylesheet" type="text/css" >
        <xsl:attribute name="href" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/css/Ext.ux.IconCombo.css</xsl:text>
        </xsl:attribute>
    </link>

    <!-- i18n : "fr_CA" -->
    <xsl:if test="$g_locale = 'fr_CA'">
        <script>
            <xsl:attribute name="src" >
                <xsl:value-of select="$g_widgets_url"/>
                <xsl:text>/filetreepanel/locale/fr_FR.js</xsl:text>
            </xsl:attribute>
        </script>
    </xsl:if>

    <!-- org.GeoPrisma.FileTreePlugin sources -->
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/org.GeoPrisma.FileTreePlugin.js</xsl:text>
        </xsl:attribute>    
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/org.GeoPrisma.FileTreeFileUpload.js</xsl:text>
        </xsl:attribute>    
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/org.GeoPrisma.FileTreeNewFolder.js</xsl:text>
        </xsl:attribute>    
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/org.GeoPrisma.FileTreeCascade.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/filetreepanel/js/org.GeoPrisma.form.FileUploadFormPanel.js</xsl:text>
        </xsl:attribute>    
    </script>

    <!-- i18n : "fr_CA" -->
    <xsl:if test="$g_locale = 'fr_CA'">
        <script>
            <xsl:attribute name="src" >
                <xsl:value-of select="$g_widgets_url"/>
                <xsl:text>/filetreepanel/locale/org.GeoPrisma.fr_CA.js</xsl:text>
            </xsl:attribute>
        </script>
    </xsl:if>

    <script type="text/javascript">
    var objGPWidget<xsl:value-of select="$WidgetType" />Container = [];
    </script>
   </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="filetreepanel:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <!-- get draw mode  -->
    <xsl:variable name="pDrawMode">
      <xsl:value-of select="$drawmode" />
    </xsl:variable>

    <xsl:variable name="WidgetType">
      <xsl:value-of select="./type"/>
    </xsl:variable>
    <xsl:variable name="ServiceType">
      <xsl:text>file</xsl:text>
    </xsl:variable>

    <xsl:variable name="serviceName">
      <xsl:value-of select="./options/servicename" />
    </xsl:variable>

    <script type="text/javascript">
        Ext.QuickTips.init();
        Ext.form.Field.prototype.msgTarget = 'side';

        var fileServiceURL = Ext.urlAppend('<xsl:value-of select="$proxyurl" />', 'osmservice=<xsl:value-of select="$serviceName" />');

        var defaultOptions = {
            url: fileServiceURL,
            title: '<xsl:value-of select="php:functionString('FileTreePanel::getText','i18n_panel_title','JS')" />',
            id: 'ftp',
            border: false,
            rootVisible: false,
            rootPath: 'root',
            topMenu: false,
            readOnly: true,
            enableDD: false,
            autoScroll: true,
            enableProgress: false,
            openMode: 'download',
            plugins: [new org.GeoPrisma.FileTreeCascade()]
        };

        var widgetOptions = Ext.applyIf(
          <xsl:for-each select="./options">
            <xsl:call-template name="getObjectFromNode">
              <xsl:with-param name="pNode" select="." />
            </xsl:call-template>
          </xsl:for-each>, defaultOptions);

        <xsl:variable name="enableTopToolbar">
          <xsl:choose>
            <xsl:when test="./options/enableUpload = 'true'" >1</xsl:when>
            <xsl:when test="./options/enableNewFolder = 'true'" >1</xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:if test="$enableTopToolbar = 1">
          Ext.apply(widgetOptions, {
            <!-- readOnly set false to let the Ext.ux.FileTreePanel create
                 the treeEditor.  The context menu on right click is then
                 blocked by overriding the onContextMenu method. -->
              readOnly: false,
              onContextMenu: function() {
                  return false;
              },
              tbar: new Ext.Toolbar()
          });
          <xsl:if test="./options/enableUpload = 'true'" >
          var uploadPanelOptions = {
              url: fileServiceURL,
              path: 'root'
          };
          widgetOptions.plugins.push(new org.GeoPrisma.FileTreeFileUpload({
              uploadPanelOptions: uploadPanelOptions
          }));
          </xsl:if>
          <xsl:if test="./options/enableNewFolder = 'true'" >
          widgetOptions.plugins.push(new org.GeoPrisma.FileTreeNewFolder());
          </xsl:if>
        </xsl:if>

        <!-- i18n title support -->
        <xsl:if test="./options/title">
          widgetOptions.title = <xsl:for-each select="./options/title"><xsl:call-template name="getText" /></xsl:for-each>;
        </xsl:if>

        objGPWidget<xsl:value-of select="$WidgetType" />Container.push(
            new Ext.ux.FileTreePanel(widgetOptions)
        );
    </script>
  </xsl:template>
  <!-- printWidgetExecution END  -->

  <!-- drawWidget START  -->
  <xsl:template name="filetreepanel:drawWidget">
    <xsl:param name="pWidgetName" />
      objGPWidget<xsl:value-of select="$pWidgetName" />
  </xsl:template>
  <!-- drawWidget END  -->

  <!-- 
       Method: drawWidgets
         Add the objGPWidget<WidgetType>Container object to an other given
         container

       Properties:
         pContainer - objGPWidget<WidgetType>Container is added to this object
         WidgetType - The widget type
    -->
  <!-- drawWidgets START  -->
  <xsl:template name="filetreepanel:drawWidgets">
    <xsl:param name="pContainer" />

    <xsl:variable name="WidgetType">
      <xsl:text>filetreepanel</xsl:text>
    </xsl:variable>
	if (typeof(objGPWidget<xsl:value-of select="$WidgetType" />Container) != 'undefined' &amp;&amp; typeof(<xsl:value-of select="$pContainer" />) != 'undefined')
    {
        for (var i=0, len=objGPWidget<xsl:value-of select="$WidgetType" />Container.length; i&lt;len; i++) {
            if(<xsl:value-of select="$pContainer" />['ctype']){
                <xsl:value-of select="$pContainer" />.add(
                    objGPWidget<xsl:value-of select="$WidgetType" />Container[i]
                );
            } else {
                <xsl:value-of select="$pContainer" />.items.push(
                    objGPWidget<xsl:value-of select="$WidgetType" />Container[i]
                )
            }
        }
    }
  </xsl:template>
  <!-- drawWidgets END  -->

</xsl:stylesheet>
