<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:geoexttoolbar="http://geoprisma.org/geoexttoolbar"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

<!-- 
     Developper notice

     In order to have other widgets to be added to this GeoExtToolbar widget,
     they MUST define 2 javascript objects with the following names :

     objGPWidget<xsl:value-of select="$WidgetType" />GeoExtToolbarOptions
     objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions

     Even if a widget should always use only one of the two objects, the other
     must be defined as well to avoid javascript errors.

     For an example, see the QueryOnClick widget.
-->

<!-- 
     Function : printWidgetSource

     Print the source code for this widget
-->
  <!-- Call for each widget type-->
  <xsl:template name="geoexttoolbar:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>geoexttoolbar</xsl:text>
    </xsl:variable>

        <link rel="stylesheet" type="text/css" >
        <xsl:attribute name="href" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/geoexttoolbar/resources/css/GeoExtToolbar.css</xsl:text>
        </xsl:attribute>
    </link>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/geoexttoolbar/lib/org.GeoPrisma.GeoExtToolbar.js</xsl:text>
        </xsl:attribute>    
    </script>

     <!-- Traduction (extjs method)
                http://extjs.com/learn/Tutorial:Localizing_Ext#Application_Localization
        --> 
    <script>
                
        Ext.apply(org.GeoPrisma.GeoExtToolbar.prototype, {
            i18n_zoomfull_tooltip : <xsl:value-of select="php:functionString('GeoExtToolbar::getText','i18n_zoomfull_tooltip','JS')" />,  
            i18n_zoomin_tooltip   : <xsl:value-of select="php:functionString('GeoExtToolbar::getText','i18n_zoomin_tooltip','JS')" />,  
            i18n_zoomout_tooltip  : <xsl:value-of select="php:functionString('GeoExtToolbar::getText','i18n_zoomout_tooltip','JS')" />,  
            i18n_pan_tooltip      : <xsl:value-of select="php:functionString('GeoExtToolbar::getText','i18n_pan_tooltip','JS')" />,  
            i18n_back_tooltip     : <xsl:value-of select="php:functionString('GeoExtToolbar::getText','i18n_back_tooltip','JS')" />,  
            i18n_next_tooltip     : <xsl:value-of select="php:functionString('GeoExtToolbar::getText','i18n_next_tooltip','JS')" />  
        });        

    </script>

    <!-- Activate tooltips AND add more elements to the toolbar.  Since this is
         done in a Ext.onReady, it's executed after each widget were parsed.
      -->
    <script type="text/javascript">
      org.GeoPrisma.GeoExtToolbarSingleton = new org.GeoPrisma.GeoExtToolbar();
      objGPWidget<xsl:value-of select="$WidgetType" /> = org.GeoPrisma.GeoExtToolbarSingleton;
        
      Ext.onReady(function() {
          Ext.QuickTips.init();

          
          var searchFunction = function(object)
                                {
                                    return (object == this.objValue || (object.initialConfig.menu != null &amp;&amp; this.objValue.menu != null &amp;&amp; object.initialConfig.menu == this.objValue.menu))
                                };
          
      <xsl:for-each select="/geoprisma/widgets/widget[./type = $WidgetType]">
        <xsl:variable name="WidgetName">
          <xsl:value-of select="./name"/>
        </xsl:variable>

        <xsl:variable name="separateEditFeatureWidgets">
          <xsl:value-of select="./options/separateEditFeatureWidgets"/>
        </xsl:variable>

        var bLastNodeWasSeparator = true;
        <!-- for each node -->
        <xsl:for-each select="./options//widget">
          <xsl:choose>
            <!-- If the node is a separator, simply add it -->
            <xsl:when test=". = '__separator__'">
                if(!bLastNodeWasSeparator) {
                    objGPWidget<xsl:value-of select="$WidgetType" />.add('-');
                    bLastNodeWasSeparator = true;
                }
            </xsl:when>

            <xsl:when test=". = '__editfeature__'">
                bLastNodeWasSeparator = false;
                if (Ext.isDefined(window.goEditFeatureActions)) {
                    for (var resource in goEditFeatureActions) {
                        var resourceEditActions = goEditFeatureActions[resource];
                        var createActions = [];
                        var updateActions = [];
                        var deleteActions = [];
                        var splitActions = [];
                        var dragActions = [];
                        var copyActions = [];
                        Ext.each(resourceEditActions, function(resourceEditAction, index){
                            if (OpenLayers.Control.EditFeature_Create &amp;&amp;
                                resourceEditAction.control instanceof OpenLayers.Control.EditFeature_Create) {
                                createActions.push(resourceEditAction);
                            } else if (OpenLayers.Control.EditFeature_Update &amp;&amp;
                                resourceEditAction.control instanceof OpenLayers.Control.EditFeature_Update) {
                                updateActions.push(resourceEditAction);
                            } else if (OpenLayers.Control.EditFeature_Delete &amp;&amp;
                                resourceEditAction.control instanceof OpenLayers.Control.EditFeature_Delete) {
                                deleteActions.push(resourceEditAction);
                            } else if (OpenLayers.Control.EditFeature_Split &amp;&amp;
                                resourceEditAction.control instanceof OpenLayers.Control.EditFeature_Split) {
                                splitActions.push(resourceEditAction);
                            } else if (OpenLayers.Control.EditFeature_Drag &amp;&amp;
                                resourceEditAction.control instanceof OpenLayers.Control.EditFeature_Drag) {
                                dragActions.push(resourceEditAction);
                            } else if (OpenLayers.Control.EditFeature_Copy &amp;&amp;
                                resourceEditAction.control instanceof OpenLayers.Control.EditFeature_Copy) {
                                copyActions.push(resourceEditAction);
                            }
                        }, this);

                        var allEditActions = createActions.concat(updateActions,dragActions,copyActions,deleteActions,splitActions);
                        Ext.each(allEditActions, function(editAction, index) {
                            objGPWidget<xsl:value-of select="$WidgetType" />.add(editAction);
                        }, this);

                        <xsl:if test="$separateEditFeatureWidgets != 'false'">
                          objGPWidget<xsl:value-of select="$WidgetType" />.add('-');
                          bLastNodeWasSeparator = true;
                        </xsl:if>
                    }
                }
            </xsl:when>

            <!-- If the node is a widget -->
            <xsl:otherwise>
              <xsl:variable name="pWidgetNameToAdd">
                <xsl:value-of select="." />
              </xsl:variable>

              <xsl:variable name="pWidgetTypeToAdd">
                  <xsl:call-template name="getWidgetTypeByName">
                    <xsl:with-param name="pWidgetName" select="$pWidgetNameToAdd" />
                  </xsl:call-template>
              </xsl:variable>

              <!-- Check if widget has a geoext toolbar option object.  If so,
                   add it to the toolbar.
                -->

              if(typeof(objGPWidget<xsl:value-of select="$pWidgetNameToAdd" />GeoExtToolbarOptions) != "undefined"){
                  objGPWidget<xsl:value-of select="$WidgetType" />.add(
                      objGPWidget<xsl:value-of select="$pWidgetNameToAdd" />GeoExtToolbarOptions
                  );
                  bLastNodeWasSeparator = false;
              }

              <!-- Check if widget type has a geoext toolbar option object.  If
                   so and it's not already added, add it to the toolbar.
                -->  
              if(typeof(objGPWidget<xsl:value-of select="$pWidgetTypeToAdd" />GeoExtToolbarOptions) != "undefined" &amp;&amp;

                 objGPWidget<xsl:value-of select="$WidgetType" />.items.find(searchFunction , {objValue : objGPWidget<xsl:value-of select="$pWidgetTypeToAdd" />GeoExtToolbarOptions}) == null){
                  objGPWidget<xsl:value-of select="$WidgetType" />.add(
                      objGPWidget<xsl:value-of select="$pWidgetTypeToAdd" />GeoExtToolbarOptions
                  );
                  bLastNodeWasSeparator = false;
              }
            </xsl:otherwise>
          </xsl:choose>

        </xsl:for-each>
      </xsl:for-each>


      <!-- Manual toolbar items deactivation 
           
           After all items were added to the array (above), we create a
           Ext.Toolbar from this array (overwrite the name of the object).  We
           then register a "afterrender" event to add a on "click" listener to
           all the toolbar items that have a group or that are inside a menu.

           Without this fix, the toolbar has the following behaviour :
           When a button is clicked, all other buttons that share the same group
           are automatically unpressed and according OpenLayers controls 
           deactivated, but not items from menu items even if they also share 
           the same group.  The opposite is also true (activation of menu items
           don't deactivate buttons).  That way, we can have 2 controls
           activated at the same time, but only one is working.

           See GeoExtToolbar.js for more.

           N.B.: "afterrender" only supported with Ext 3.0.0
        -->  
        
         }
      );  
    </script>

   </xsl:template>

<!-- 
     Function : printWidgetExecution

     Print the execution code for this widget
-->
  <!-- Call for each widget name-->
  <xsl:template name="geoexttoolbar:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <!-- javascript START -->
    <script type="text/javascript">
      <!-- Quick reference to the Map object -->
      oMap = objGPWidget<xsl:value-of select="$pMapName"/>;

          objWidgetOptions =
          <xsl:for-each select="./options">
            <xsl:call-template name="getObjectFromNode">
              <xsl:with-param name="pNode" select="." />
            </xsl:call-template>
          </xsl:for-each>;

      <!-- Initialize toolbar content (array) -->
      org.GeoPrisma.GeoExtToolbarSingleton.initContent(oMap, objWidgetOptions);
    </script>
    <!-- javascript END -->
  </xsl:template>

<!-- 
     Function : drawWidget

     Output the widget depending on the render type
-->
  <!-- Call for each widget name -->
  <xsl:template name="geoexttoolbar:drawWidget">
    <xsl:param name="pWidgetName" />
     <!-- vide -->
  </xsl:template>

<!-- 
     Function : drawWidgets
     Returns what's needed to create the toolbar widget.  

     Output the widget depending on the render type
-->
  <!-- Call for each widget name -->
  <xsl:template name="geoexttoolbar:drawWidgets">
    <xsl:variable name="WidgetType">
      <xsl:text>geoexttoolbar</xsl:text>
    </xsl:variable>

    <xsl:if test="count(/geoprisma/widgets/widget[./type = $WidgetType]) > 0 ">
      tbar: org.GeoPrisma.GeoExtToolbarSingleton,
    </xsl:if>
  </xsl:template>

<!--
    Function: getWidgetDepedencies

    Return the list of dependencies for this widget
-->
  <!-- Call for each widget type-->
  <xsl:template name="geoexttoolbar:getWidgetDepedencies">

  </xsl:template>

</xsl:stylesheet>
