<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:geoextux_shortcutcombo="http://geoprisma.org/geoextux_shortcutcombo"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="geoextux_shortcutcombo:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_shortcutcombo</xsl:text>
    </xsl:variable>

    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-shortcutcombo/ux/widgets/form/ShortcutCombo.js</xsl:text>
        </xsl:attribute>
    </script>

    <script type="text/javascript">
      var objGPWidget<xsl:value-of select="$WidgetType" />Lang = {
          'title': "Zoom To"
      };
    </script>

    <!-- i18n : "fr_CA" -->
    <xsl:if test="$g_locale = 'fr_CA'">
      <script>
        <xsl:attribute name="src" >
          <xsl:value-of select="$g_widgets_url"/>
          <xsl:text>/geoextux/shortcutcombo/resources/lang/fr.js</xsl:text>
        </xsl:attribute>
      </script>
    </xsl:if>
    
    <script type="text/javascript">
      var objGPWidget<xsl:value-of select="$WidgetType" />GeoExtToolbarOptions = [];
      objGPWidget<xsl:value-of select="$WidgetType" />FormPanel = Ext.applyIf({
          layout: 'form',
          border: false,
          defaults: {hideLabel: true},
          bodyStyle:'padding:5px 0px 0',
          items: []
      }, objGPWidget<xsl:value-of select="$WidgetType" />Lang);
    </script>

   </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="geoextux_shortcutcombo:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_shortcutcombo</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      oMap = objGPWidget<xsl:value-of select="$pMapName"/>;
      var objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions;

      var objWidgetOptions = {};
      var objWidgetTitle = '';
      <xsl:for-each select="./options/*">
      <xsl:choose>
        <xsl:when test="name() = 'title'">
         objWidgetTitle = "<xsl:value-of select='.'/>";
	</xsl:when>
        <xsl:when test="name() = 'store'">
          objWidgetOptions.store = <xsl:value-of select='.'/>;
	</xsl:when>
        <xsl:otherwise>
           objWidgetOptions['<xsl:value-of select='name()'/>'] = "<xsl:value-of select='.'/>";
        </xsl:otherwise>
      </xsl:choose>
      </xsl:for-each>
      objWidgetOptions['map'] = oMap;

     var objGPWidget<xsl:value-of select="$pWidgetName" /> =
          new GeoExt.ux.ShortcutCombo(objWidgetOptions);
     objGPWidget<xsl:value-of select="$pWidgetName" />.title = objWidgetTitle;
     objGPWidget<xsl:value-of select="$pWidgetName" />.emptyText = objWidgetTitle;
          
      <!-- FormPanel support  -->
      objGPWidget<xsl:value-of select="$WidgetType" />FormPanel.items.push(objGPWidget<xsl:value-of select="$pWidgetName" />);
      
      <!-- Toolbar support -->
      objGPWidget<xsl:value-of select="$WidgetType" />GeoExtToolbarOptions.push(objGPWidget<xsl:value-of select="$pWidgetName" />);


    </script>
  </xsl:template>
  <!-- printWidgetExecution END  -->

  <xsl:template name="geoextux_shortcutcombo:drawWidgets">
    <xsl:param name="pContainer" />

    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_shortcutcombo</xsl:text>
    </xsl:variable>

    	if (typeof(objGPWidget<xsl:value-of select="$WidgetType" />FormPanel) != 'undefined' &amp;&amp; typeof(<xsl:value-of select="$pContainer" />) != 'undefined')
    {
        if(<xsl:value-of select="$pContainer" />['ctype']){
            <xsl:value-of select="$pContainer" />.add(
                objGPWidget<xsl:value-of select="$WidgetType" />FormPanel
            );
        } else {
            <xsl:value-of select="$pContainer" />.items.push(
                objGPWidget<xsl:value-of select="$WidgetType" />FormPanel
            )
        }
    }
  </xsl:template>

  <xsl:template name="geoextux_shortcutcombo:getWidgetDepedencies">
  </xsl:template>

</xsl:stylesheet>
