<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:geoextux_wmsbrowser="http://geoprisma.org/geoextux_wmsbrowser"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="geoextux_wmsbrowser:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_wmsbrowser</xsl:text>
    </xsl:variable>

    <!-- GeoExt.ux.WMSBrowser source -->
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-wmsbrowser/lib/GeoExt.ux/data/Store.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-wmsbrowser/lib/GeoExt.ux/data/WMSBrowserWMSCapabilitiesStore.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-wmsbrowser/lib/GeoExt.ux/plugins/WMSBrowserAlerts.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-wmsbrowser/lib/GeoExt.ux/widgets/WMSBrowser.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-wmsbrowser/lib/GeoExt.ux/widgets/WMSBrowserStatusBar.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-wmsbrowser/lib/GeoExt.ux/widgets/grid/WMSBrowserGridPanel.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-wmsbrowser/lib/GeoExt.ux/widgets/tree/WMSBrowserRootNode.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-wmsbrowser/lib/GeoExt.ux/widgets/tree/WMSBrowserTreePanel.js</xsl:text>
        </xsl:attribute>
    </script>
    
    <!-- CSS -->
    <link rel="stylesheet" type="text/css" >
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_lib_url"/>
        <xsl:text>/geoext-ux-wmsbrowser/resources/css/WMSBrowser.css</xsl:text>
      </xsl:attribute>
    </link>

    <!-- i18n : "fr_CA" -->
    <xsl:if test="$g_locale = 'fr_CA'">
        <script>
            <xsl:attribute name="src" >
                 <xsl:value-of select="$g_lib_url"/>
                 <xsl:text>/geoext-ux-wmsbrowser/resources/lang/fr.js</xsl:text>
            </xsl:attribute>
        </script>
    </xsl:if>

    <script type="text/javascript">
      var objGPWidget<xsl:value-of select="$WidgetType" />GeoExtToolbarOptions, browserWindow;
    </script>

   </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="geoextux_wmsbrowser:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_wmsbrowser</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      oMap = objGPWidget<xsl:value-of select="$pMapName"/>;
      var objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions;

      <!-- Widget object creation -->
      var action<xsl:value-of select="$pWidgetName" /> = new Ext.Action({
          text: 'WMSBrowser',
          handler: function(){

            var objWidgetOptions = {};
           <xsl:for-each select="./options">
             objWidgetOptions =
               <xsl:call-template name="getObjectFromNode">
                 <xsl:with-param name="pNode" select="." />
               </xsl:call-template>;
           </xsl:for-each>
           objWidgetOptions['map'] = oMap;

            var oMyMapPanel;
            if(window.objGPWidgetMapPanel<xsl:value-of select="$pMapName" /> != undefined) {
                oMyMapPanel = objGPWidgetMapPanel<xsl:value-of select="$pMapName" />;
            } else {
                oMyMapPanel = GeoExt.MapPanel.guess();
            }

            var aServerURLs = [], aszServers = [];
            if(objWidgetOptions.servers) {
                aServerURLs = objWidgetOptions.servers;
            }
            else if(objWidgetOptions.server) {
                aServerURLs = [objWidgetOptions.server];
            }
            for(var i=0; i&lt;aServerURLs.length; i++)
            {
                aszServers.push([aServerURLs[i]]);
            }

            var oServerStore = new Ext.data.SimpleStore({
              fields: ['url'],
              data : aszServers
            });

            if(!browserWindow) {
              var myBrowserOptions = Ext.apply(objWidgetOptions, {
                border: false,
                region: "east",
                zoomOnLayerAdded: false,
                closeOnLayerAdded: false,
                allowInvalidUrl: true,
                alertPopupTimeout: 2000,
                // === proxyHost === uncomment to use the local proxy.php
                proxyHost: "<xsl:value-of select="$proxyurl" />?osmservice=__blank__&amp;osmwidgettype=geoextux_wmsbrowser&amp;osmprocess=proxy&amp;url=",
                // comment the below line to have a 'textfield' instead of a 
                // 'combobox'.  oServerStore is in ./store.js
                serverStore: oServerStore,
                mapPanelPreviewOptions: {height: 170, collapsed: false},
                layerStore: oMyMapPanel.layers
              });

              WMSBrowser = new GeoExt.ux.WMSBrowser(myBrowserOptions);

              browserWindow = new Ext.Window({
                resizable: true,
                modal: false,
                closeAction: 'hide',
                width: 550,
                height: 450,
                title: OpenLayers.i18n("WMSBrowser"),
                layout: 'fit',
                items: [WMSBrowser]
              });
            }

            browserWindow.show();

          },
          scope: this,
          tooltip: OpenLayers.i18n('Add currently selected layers')
      });

      <!-- draw in toolbar -->
      objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions =
          action<xsl:value-of select="$pWidgetName" />;

    </script>

  </xsl:template>
  <!-- printWidgetExecution END  -->

</xsl:stylesheet>
