<?php
/* 
   Copyright (c) 2009- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. 
*/ 

class GeoExtux_WMSBrowser extends org_geoprisma_widget_WidgetBase
{
    static public function getText($pstrMsg, $pstrType = null)
    {
        return parent::getText($pstrMsg, self::getType(), $pstrType);
    }

    static public function getAction()
    {
        return 'read';
    }    
     
    static public function getType()
    {
        return 'geoextux_wmsbrowser';
    }

    static public function getServiceType()
    {
        return null;
    }
	
    static public function getProcessList()
    {
        return array(
            "proxy"
        );	
    }

    static public function proxy()
    {
        $pobjWidget = func_get_arg(0);

        $url = self::sanitizeURL($_REQUEST["url"]);

        if(stripos($url, 'request=GetCapabilities') === false || 
           stripos($url, 'service=WMS') === false ||
           !self::validateWhitelist($pobjWidget, $url) || !self::validateBlacklist($pobjWidget, $url))
            return;

        ob_start();
        $objCurl = curl_init($url);                
        curl_exec($objCurl);
        $objArrayInfo = curl_getinfo($objCurl);
        curl_close($objCurl);
        header("Content-type: $objArrayInfo[content_type]");
        ob_end_flush();
    }

    static public function validateWhitelist($pobjWidget, $pstrURL)
    {
        $bReturn = true;
        
        try
        {
            $objOption = $pobjWidget->getOption('whitelistedURL');

            $bReturn = false;
            if(strpos($pstrURL, $objOption->getValue()) == 0 &&
               strpos($pstrURL, $objOption->getValue()) !== false)
            {
                $bReturn = true;
            }
        }
        catch (Exception $objError)
        {
            try
            {
                $objOptions = $pobjWidget->getOption('whitelistedURLs');

                $bReturn = false;
                foreach($objOptions->getValue() as $objOption)
                {
                    if(strpos($pstrURL, $objOption) == 0 &&
                       strpos($pstrURL, $objOption) !== false)
                    {
                        $bReturn = true;
                        break;
                    }
                }
            }
            catch (Exception $objError) {}
        }

        return $bReturn;
    }

    static public function validateBlacklist($pobjWidget, $pstrURL)
    {
        $bReturn = true;
        
        try
        {
            $objOption = $pobjWidget->getOption('blacklistedURL');

            if(strpos($pstrURL, $objOption->getValue()) == 0 &&
               strpos($pstrURL, $objOption->getValue()) !== false)
            {
                $bReturn = false;
            }
        }
        catch (Exception $objError)
        {
            try
            {
                $objOptions = $pobjWidget->getOption('blacklistedURLs');

                foreach($objOptions->getValue() as $objOption)
                {
                    if(strpos($pstrURL, $objOption) == 0 &&
                       strpos($pstrURL, $objOption) !== false)
                    {
                        $bReturn = false;
                        break;
                    }
                }
            }
            catch (Exception $objError) {}
        }

        return $bReturn;
    }

    static public function sanitizeURL($pstrURL)
    {
        $objURLParts = parse_url($pstrURL);

        $objPath = explode('/', $objURLParts['path']);

        $objSanitizedPath = array();
        foreach($objPath as $strPart)
        {
            if($strPart == '..')
            {
                if(count($objSanitizedPath) >= 1)
                {
                    array_pop($objSanitizedPath);
                }
            }
            else
            {
                $objSanitizedPath[] = $strPart;
            }
        }

        $strPath = implode('/', $objSanitizedPath);

        return str_replace($objURLParts['path'], $strPath, $pstrURL);
    }
}
  
?>
