<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2010- Groupe Nippour, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.	
  --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:dyn="http://exslt.org/dynamic"
                xmlns:htwindow="http://geoprisma.org/htwindow"
                extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="htwindow:printWidgetSource">
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/htwindow/HTWindow.js</xsl:text>
      </xsl:attribute>    
    </script>
    <link rel="stylesheet" type="text/css" >
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/htwindow/HTWindow.css</xsl:text>
      </xsl:attribute>
    </link>
  </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="htwindow:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <!-- get draw mode  -->
    <xsl:variable name="pDrawMode">
      <xsl:value-of select="$drawmode" />
    </xsl:variable>

    <script type="text/javascript">
      
      <!-- Config options-->
      var objWidgetOptions = {};
      <xsl:for-each select="./options">
        objWidgetOptions =
        <xsl:call-template name="getObjectFromNode">
          <xsl:with-param name="pNode" select="." />
        </xsl:call-template>;
      </xsl:for-each>

      <xsl:if test="./options/formmethod != ''">
        objWidgetOptions.formmethod = <xsl:value-of select="./options/formmethod" />;
      </xsl:if>
      
      var objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions;   

      var objGPWidget<xsl:value-of select="$pWidgetName" /> =    
      new OpenLayers.Control.HTWindow({
          formurl:objWidgetOptions['formurl'],
          formmethod:objWidgetOptions['formmethod'],
          id:objWidgetOptions['id'],
          text:unescape('<xsl:value-of select="./options/text" />'),
          windowW:objWidgetOptions['width'],
          windowH:objWidgetOptions['height'],
          windowM:objWidgetOptions['modal'],
          windowC:objWidgetOptions['collapsible']
      });

      objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions = new GeoExt.Action({
      iconCls: ('<xsl:call-template name="getWidgetOptionByName">
        <xsl:with-param name="pWidgetName" select="$pWidgetName" />        
        <xsl:with-param name="pOptionName">
          <xsl:text>iconcls</xsl:text>
        </xsl:with-param>
      </xsl:call-template>'=='')?'htwindow': '<xsl:call-template name="getWidgetOptionByName">
        <xsl:with-param name="pWidgetName" select="$pWidgetName" />        
        <xsl:with-param name="pOptionName">
          <xsl:text>iconcls</xsl:text>
        </xsl:with-param>
      </xsl:call-template>',
      control: objGPWidget<xsl:value-of select="$pWidgetName" />,
      <xsl:if test="./options/text">text: unescape('<xsl:value-of select="./options/text" />'),</xsl:if>
      tooltip: unescape('<xsl:call-template name="getWidgetOptionByName">
        <xsl:with-param name="pWidgetName" select="$pWidgetName" />        
        <xsl:with-param name="pOptionName">
          <xsl:text>tooltip</xsl:text>
        </xsl:with-param>
      </xsl:call-template>')
      });

      /*
      '<xsl:value-of select="php:functionString('HTWindow::getText','i18n_htwindow_tooltip','JS')" />' 
      */      
    </script>
  </xsl:template>
  <!-- printWidgetExecution END  -->

</xsl:stylesheet>
