<?php
/* 
   Copyright (c) 2009-2012 Mapgears Inc.
   Published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. 
*/ 

class InitialView extends org_geoprisma_widget_WidgetBase
{
    static public function getText($pstrMsg)
    {
        return parent::getText($pstrMsg, self::getType());
    }
     
    static public function getAction()
    {
        return 'read';
    }    
     
    static public function getType()
    {
        return 'initialview';
    }

    static public function getServiceType()
    {
        return null;
    }

    static public function getLocalViewIndex($pstrWidgetName)
    {
        // detect local field parameter
        try
        {
            $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
            $objWidget = $objConfig->getWidget($pstrWidgetName);
            $strField = $objWidget->getOption("localViewField")->getValue();
        }
        catch (Exception $objError) {
            $strField = "localViewField";
        }

        // check if local field is set in request and get its value
        if (isset($_REQUEST) && isset($_REQUEST[$strField]))
        {
            $iIndex = $_REQUEST[$strField];
        }
        else
        {
            $iIndex = 0;
        }

        return $iIndex;
    }

    static public function getFeature($pstrResourceName, $pstrServiceType) 
    {
        if ($pstrResourceName == null || $pstrServiceType == null) 
        {
            return "";
        }

        $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
        $objResource = $objConfig->getResource($pstrResourceName);
        $strField = $objResource->getOption("initViewUrlField")->getValue();

        // check if field is not in url or empty
        if (!isset($_REQUEST) || !isset($_REQUEST[$strField]) || $_REQUEST[$strField] == null)
        {
            return "";
        }

        $strFeaturesString = "";

        switch ($pstrServiceType) 
        {
            case org_geoprisma_service_FeatureServerService::TYPE:
                $strFeaturesString = $objResource->getFeature(
                    $pstrServiceType, $_REQUEST[$strField]
                );
                break;
            case org_geoprisma_service_WFSService::TYPE:
                // todo
                break;
        }

        return $strFeaturesString;
    }

    static function getURLFieldValue($pstrResourceName) 
    {
        if ($pstrResourceName == null) 
        {
            return "";
        }

        $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
        $objResource = $objConfig->getResource($pstrResourceName);
        $strField = $objResource->getOption("initViewUrlField")->getValue();

        // check if field is not in url or empty
        if (!isset($_REQUEST) || !isset($_REQUEST[$strField]) || $_REQUEST[$strField] == null)
        {
            return "";
        }
        else
        {
            return $_REQUEST[$strField];

        }
    }
}
  
?>
