/* 
   Copyright (c) 2011- Solution Globale, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. 
*/ 

Ext.namespace("org.GeoPrisma");

/** api: (define)
 *  module = org.GeoPrisma
 *  class = KeepActiveSession
 */

/** api: constructor
 *  .. class:: KeepActiveSession
 */
org.GeoPrisma.KeepActiveSession = Ext.extend(Ext.util.Observable, {

    /* API Properties */

    /** api: property[url]
     * ``String``
     * url of proxy to call
     */
    url: null,

    /** api: property[delay]
     * ``Integer``
     * number of second between each call
     */
    delay: 5 * 60,

    /** private: method[constructor]
     *  This class is a superconstructor only.
     */
    constructor: function(config) {
        Ext.apply(this, config);
        arguments.callee.superclass.constructor.call(this, config);
        
        // start keep session active and use createDelegate to preserve scope
        setInterval(this.sendRequest.createDelegate(this), this.delay*1000);
    },

    /** private: method[sendRequest]
     *  Send a request to server to keep session active
     */
    sendRequest: function(){
        Ext.Ajax.request({
            url: this.url,
            success: function(record) {
                return true;
            },
            failure: function(record) {
                return false;
            }
        })
    }
});