<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009-2011 Mapgears Inc.
   Published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:measuretool="http://geoprisma.org/measuretool"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <xsl:template name="measuretool:printWidgetSource">

    <!-- CSS -->
    <link rel="stylesheet" type="text/css" >
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/measuretool/resources/css/measuretool.css</xsl:text>
      </xsl:attribute>
    </link>

    <!-- JS -->
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/measuretool/lib/org.GeoPrisma.MeasureTool.js</xsl:text>
      </xsl:attribute>    
    </script>

    <!-- i18n : "fr_CA" -->
    <xsl:if test="$g_locale = 'fr_CA'">
      <script>
        <xsl:attribute name="src" >
          <xsl:value-of select="$g_widgets_url"/>
          <xsl:text>/measuretool/resources/lang/fr.js</xsl:text>
        </xsl:attribute>
      </script>
    </xsl:if>
    
   </xsl:template>

  <xsl:template name="measuretool:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <script type="text/javascript"> 
      var widgetOptions = Ext.applyIf({
          mapPanel: objGPWidgetMapPanel<xsl:value-of select="$pMapName" />,
          toggleGroup: objGPWidget<xsl:value-of select="$pMapName" />.id
      }, 
      <xsl:for-each select="./options">
        <xsl:call-template name="getObjectFromNode">
          <xsl:with-param name="pNode" select="." />
        </xsl:call-template>
      </xsl:for-each>);

      var objGPWidget<xsl:value-of select="$pWidgetName" /> =
          new org.GeoPrisma.MeasureTool(widgetOptions);
      
      <!-- options for the GeoExtToolbar -->
      objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions =
          objGPWidget<xsl:value-of select="$pWidgetName" />;
   </script>
  </xsl:template>
</xsl:stylesheet>
