<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:pdfprint="http://geoprisma.org/pdfprint"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

<!-- 
     Function : printWidgetSource

     Print the source code for this widget
-->
  <!-- Call for each widget type-->
  <xsl:template name="pdfprint:printWidgetSource">
  	<link rel="stylesheet" type="text/css" >
  		<xsl:attribute name="href" >
            <xsl:value-of select="$g_widgets_url"/>
            <xsl:text>/pdfprint/PDFPrint.css</xsl:text>
        </xsl:attribute>
    </link>   
    
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/pdfprint/PDFPrint.js</xsl:text>
        </xsl:attribute>    
    </script>
   </xsl:template>

<!-- 
     Function : printWidgetExecution

     Print the execution code for this widget
-->
  <!-- Call for each widget name-->
  <xsl:template name="pdfprint:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <!-- get draw mode  -->
    <xsl:variable name="pDrawMode">
      <xsl:value-of select="$drawmode" />
    </xsl:variable>

    <!-- javascript START -->
    <script type="text/javascript">
		oMap = objGPWidget<xsl:value-of select="$pMapName" />;
		
		var templates = 
			<xsl:for-each select="./options/templates">
				<xsl:call-template name="getObjectFromNode">
				  <xsl:with-param name="pNode" select="./template" />
				</xsl:call-template>
			</xsl:for-each>;
		
		// If there is only one layer
		if (templates.template){
			templates = Array(templates.template);
		}
	
		objGPWidget<xsl:value-of select="$pWidgetName" /> = new OpenLayers.Control.PDFPrint({
			i18n_tab_template_title: 	"<xsl:value-of select="php:functionString('PDFPrint::getText','i18n_tab_template_title','JS')" />",
			i18n_tab_form_title: 		"<xsl:value-of select="php:functionString('PDFPrint::getText','i18n_tab_form_title','JS')" />",
			map: oMap,
			templates: templates
		});
	
		objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions = new GeoExt.Action({
            iconCls: 'pdfprint',
            control: objGPWidget<xsl:value-of select="$pWidgetName" />,
			tooltip: '<xsl:value-of select="php:functionString('PDFPrint::getText','i18n_pdfprint_tooltip','JS')" />'
          });
		
		oMap.pdfPrint = objGPWidget<xsl:value-of select="$pWidgetName" />;
    </script>
    <!-- javascript END -->
  </xsl:template>

<!-- 
     Function : drawWidget

     Output the widget depending on the render type
-->
  <!-- Call for each widget name -->
  <xsl:template name="pdfprint:drawWidget">
    <xsl:param name="pWidgetName" />
      objGPWidget<xsl:value-of select="$pWidgetName" />
  </xsl:template>


<!--
    Function: getWidgetDepedencies

    Return the list of dependencies for this widget
-->
  <!-- Call for each widget type-->
  <xsl:template name="pdfprint:getWidgetDepedencies">

  </xsl:template>

</xsl:stylesheet>