<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 

<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:resultextgrid="http://geoprisma.org/resultextgrid"
    extension-element-prefixes="dyn">
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

<!-- 
     Function : printWidgetSource

     Print the source code for this widget
-->
  <!-- Call for each widget type-->
  <xsl:template name="resultextgrid:printWidgetSource">
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/resultextgrid/ResultExtGrid.js</xsl:text>
        </xsl:attribute>    
    </script>

    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/resultextgrid/DelegateFeature.js</xsl:text>
      </xsl:attribute>    
    </script>
    
     <!-- Traduction (utilisation de la mÃ©thode extjs)
                http://extjs.com/learn/Tutorial:Localizing_Ext#Application_Localization
        --> 
    <script>            
        Ext.apply(OpenLayers.ResultExtGrid.prototype, {
            i18n_default_panel_html :       <xsl:value-of select="php:functionString('ResultExtGrid::getText','i18n_default_panel_html','JS')" />,        
            i18n_default_panel_title :      <xsl:value-of select="php:functionString('ResultExtGrid::getText','i18n_default_panel_title','JS')" />,
            i18n_no_result_panel_html :     <xsl:value-of select="php:functionString('ResultExtGrid::getText','i18n_no_result_panel_html','JS')" />,
            i18n_no_result_panel_title :    <xsl:value-of select="php:functionString('ResultExtGrid::getText','i18n_no_result_panel_title','JS')" />,
            i18n_query_result :             <xsl:value-of select="php:functionString('ResultExtGrid::getText','i18n_query_result','JS')" />,
            i18n_message_select_row_msg :   <xsl:value-of select="php:functionString('ResultExtGrid::getText','i18n_message_select_row_msg','JS')" />,
            i18n_message_select_row_title : <xsl:value-of select="php:functionString('ResultExtGrid::getText','i18n_message_select_row_title','JS')" />,
            i18n_window_title :             <xsl:value-of select="php:functionString('ResultExtGrid::getText','i18n_window_title','JS')" />
        });   
    </script>
    
  </xsl:template>

<!-- 
     Function : printWidgetExecution

     Print the execution code for this widget
-->
  <!-- Call for each widget name-->
  <xsl:template name="resultextgrid:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <!-- get draw mode  -->
    <xsl:variable name="pDrawMode">
      <xsl:value-of select="$drawmode" />
    </xsl:variable>

    <!-- get draw mode  -->
    <xsl:variable name="resultType">
      <xsl:text>ResultExtGrid</xsl:text>
    </xsl:variable>

    <!-- inWindow -->
    <xsl:variable name="pInWindow">
      <xsl:for-each select="./options/inwindow">
        inWindow: <xsl:value-of select='.'/>,
      </xsl:for-each>
    </xsl:variable>

    <script type="text/javascript">
            var aResources = [], resource;

            <xsl:for-each select="./resources/resource">
              <!-- Resource Name -->
              <xsl:variable name="resourceName">
                <xsl:value-of select="." />
              </xsl:variable>

              <!-- Resource Title -->
              <xsl:variable name="resourceTitle">
                <xsl:for-each select="/geoprisma/resources/resource[./name = $resourceName]/title">
                  <xsl:call-template name="getText" />
                </xsl:for-each>
              </xsl:variable>

              <!-- Resource delegateContext -->
              <xsl:variable name="resourceDelegateContext">
                <xsl:for-each select="/geoprisma/resources/resource[./name = $resourceName]/options/delegateContext">
                  <xsl:call-template name="getText" />
                </xsl:for-each>
              </xsl:variable>

              <xsl:choose>
                <xsl:when test="../../options/useResponseFields = 'true'">
                  aResources.push({
                    <xsl:if test="$resourceDelegateContext != ''">
                    'delegatecontext': {
                        'enabled': true,
                        'label': <xsl:value-of select="$resourceDelegateContext" />
                    },
                    </xsl:if>
                    'displayname': <xsl:value-of select="$resourceTitle" />,
                    'resource': '<xsl:value-of select="$resourceName" />',
                    'fields': "all"
                  });
                </xsl:when>
                <xsl:when test="/geoprisma/resources/resource[./name = $resourceName]/fields != ''">
                  resource = {
                    <xsl:if test="$resourceDelegateContext != ''">
                    'delegatecontext': {
                        'enabled': true,
                        'label': <xsl:value-of select="$resourceDelegateContext" />
                    },
                    </xsl:if>
                    'displayname': <xsl:value-of select="$resourceTitle" />,
                    'resource': '<xsl:value-of select="$resourceName" />',
                    'fields': []
                  };
                  <xsl:for-each select="/geoprisma/resources/resource[./name = $resourceName]/fields/field">
                    resource.fields.push(Ext.applyIf({
                        'id': "<xsl:value-of select="./name" />",
                        'label': "<xsl:value-of select="./title" />"
                    }, <xsl:for-each select="./options"><xsl:call-template name="getObjectFromNode"><xsl:with-param name="pNode" select="./options" /></xsl:call-template></xsl:for-each>
                    ));

                  </xsl:for-each>  
                  aResources.push(resource);

                </xsl:when>
                <xsl:otherwise>
                  <xsl:for-each select="../../options/grids/grid[./resourcename = $resourceName]">
                  <!-- field properties -->
                    var aFields = [];
                    <xsl:for-each select="./fields/field">
                      aFields.push( { 'id': "<xsl:value-of select="id" />", 'label': <xsl:for-each select="label" ><xsl:call-template name="getText" /></xsl:for-each>, 'type': "<xsl:value-of select="type" />", 'width': <xsl:value-of select="width" /> } );
                    </xsl:for-each>

                    oResource = {
                      'displayname': <xsl:for-each select="displayname" ><xsl:call-template name="getText" /></xsl:for-each>,
                    <xsl:if test="delegatecontext">
                      'delegatecontext': { 'enabled':  <xsl:value-of select="delegatecontext/enabled" />, 'label': <xsl:for-each select="delegatecontext/label" ><xsl:call-template name="getText" /></xsl:for-each> }  ,
                    </xsl:if>
                      'resource': "<xsl:value-of select="$resourceName" />",
                      'fields': aFields
                    };

                    aResources.push(oResource);
                  </xsl:for-each>
                </xsl:otherwise>
              </xsl:choose>

            </xsl:for-each>

          objGPWidget<xsl:value-of select="$pWidgetName" /> = new OpenLayers.<xsl:value-of select="$resultType" />({
              <xsl:value-of select='$pInWindow'/>
              widgetName: "<xsl:value-of select="$pWidgetName" />", 
              resources: aResources,
              drawMode: "<xsl:value-of select="$drawmode" />"
          });

            <!-- Find each widget that contains this result and add it using the addResult function -->
            <!-- TODO : test this with multiple query on click  -->
            <xsl:for-each select="//options/results[./result = $pWidgetName]">
              <xsl:for-each select="../../name">
                <xsl:variable name="queryWidgetName">
                  <xsl:value-of select="." />
                </xsl:variable>

                objGPWidget<xsl:value-of select="$queryWidgetName" />.addResult(objGPWidget<xsl:value-of select="$pWidgetName" />);
                objGPWidget<xsl:value-of select="$pWidgetName" />.setQuery(objGPWidget<xsl:value-of select="$queryWidgetName" />);
              </xsl:for-each>
            </xsl:for-each>

            <xsl:for-each select="//options[./result = $pWidgetName]">
              <xsl:for-each select="../name">
                <xsl:variable name="queryWidgetName">
                  <xsl:value-of select="." />
                </xsl:variable>

                objGPWidget<xsl:value-of select="$queryWidgetName" />.addResult(objGPWidget<xsl:value-of select="$pWidgetName" />);
                objGPWidget<xsl:value-of select="$pWidgetName" />.setQuery(objGPWidget<xsl:value-of select="$queryWidgetName" />);
              </xsl:for-each>
            </xsl:for-each>
    </script>
  </xsl:template>

<!-- 
     Function : drawWidget

     Output the widget depending on the render type
-->
  <!-- Call for each widget name -->
  <xsl:template name="resultextgrid:drawWidget">
    <xsl:param name="pWidgetName" />
      objGPWidget<xsl:value-of select="$pWidgetName" />.panel
  </xsl:template>


<!--
    Function: getWidgetDepedencies

    Return the list of dependencies for this widget
-->
  <!-- Call for each widget type-->
  <xsl:template name="resultextgrid:getWidgetDepedencies">
<!-- TODO : this widget has a toolbar,map,Result.js and queryonclick dependency -->
  </xsl:template>

</xsl:stylesheet>
