<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2011- Mapgears inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:toggle="http://geoprisma.org/toggle"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <xsl:template name="toggle:printWidgetSource">
    <script type="text/javascript">
      var objGPWidgetToggle_onLayerVisibilityChanged = function(event) {
          for (var i=0, iLen=this.layers.length; i&lt;iLen; i++) {
              this.layers[i].setVisibility(event.object.getVisibility());
          }
      };
    </script>
  </xsl:template>

  <xsl:template name="toggle:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <script type="text/javascript">
      objGPWidget<xsl:value-of select="$pMapName"/>.events.on({
          "printallwidgetexecutions": function(event) {
              var motherLayers, childLayers;

              <xsl:for-each select="/geoprisma/resources/resource">
                <xsl:variable name="motherResource">
                  <xsl:value-of select="./name" />
                </xsl:variable>

                <xsl:if test="./options//toggleResource != ''">
                  motherLayers = this.getLayersByResource('<xsl:value-of select="$motherResource" />');
                </xsl:if>

                <xsl:for-each select="./options//toggleResource">
                  <xsl:variable name="childResource">
                    <xsl:value-of select="." />
                  </xsl:variable>

                  if (motherLayers &amp;&amp; motherLayers.length) {
                      childLayers = this.getLayersByResource('<xsl:value-of select="$childResource" />');
                      childLayers &amp;&amp; Ext.each(motherLayers, function(motherLayer) {
                          motherLayer.events.on({
                              "visibilitychanged" : objGPWidgetToggle_onLayerVisibilityChanged,
                              "scope": {"layers": childLayers}
                          });
                      });
                  }
                </xsl:for-each> <!-- for-each toggleResource -->
              </xsl:for-each> <!-- for-each resource -->
          }
      });
    </script>

  </xsl:template>

</xsl:stylesheet>
