<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009-2012 Mapgears Inc.
   Published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:unselectall="http://geoprisma.org/unselectall"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="unselectall:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>unselectall</xsl:text>
    </xsl:variable>

    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/unselectall/lib/org.GeoPrisma.UnselectAll.js</xsl:text>
        </xsl:attribute>    
    </script>

    <script type="text/javascript">
      var objGPWidget<xsl:value-of select="$WidgetType" />GeoExtToolbarOptions;
    </script>

   </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="unselectall:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="WidgetType">
      <xsl:text>unselectall</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      oMap = objGPWidget<xsl:value-of select="$pMapName"/>;
      var objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions;

      var objWidgetOptions = {};
      <xsl:for-each select="./options">
        objWidgetOptions =
        <xsl:call-template name="getObjectFromNode">
          <xsl:with-param name="pNode" select="." />
        </xsl:call-template>;
      </xsl:for-each>
      objWidgetOptions['map'] = oMap;

      <!-- Widget object creation -->
      var objGPWidget<xsl:value-of select="$pWidgetName" /> = 
          new org.GeoPrisma.UnselectAll(objWidgetOptions);

      <!-- draw in toolbar -->
      objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions =
          objGPWidget<xsl:value-of select="$pWidgetName" />;
    </script>

  </xsl:template>
  <!-- printWidgetExecution END  -->

</xsl:stylesheet>
