<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:wfsfilterbuilder="http://geoprisma.org/wfsfilterbuilder"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="wfsfilterbuilder:printWidgetSource"> 
    <xsl:variable name="WidgetType">
      <xsl:text>wfsfilterbuilder</xsl:text>
    </xsl:variable>

    <!-- source files from lib directory -->
    <script type="text/javascript">
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_lib_url"/>
        <xsl:text>/ext-ux-grid-search/js/Ext.ux.util.js</xsl:text>
      </xsl:attribute>
    </script>
    <script type="text/javascript">
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_lib_url"/>
        <xsl:text>/ext-ux-grid-search/js/Ext.ux.grid.Search.js</xsl:text>
      </xsl:attribute>
    </script>

    <!-- source files from widget directory -->
    <!-- CSS -->
    <link rel="stylesheet" type="text/css" >
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/wfsfilterbuilder/resources/css/wfsfilterbuilder.css</xsl:text>
      </xsl:attribute>
    </link>
    
    <!-- JS -->
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/OpenGeo/WFSFeatureStore.js</xsl:text>
        </xsl:attribute>    
    </script>   
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/OpenGeo/WFSProtocolProxy.js</xsl:text>
        </xsl:attribute>    
    </script>   
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/OpenGeo/FilterBuilder.js</xsl:text>
        </xsl:attribute>    
    </script>   
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/OpenGeo/ComparisonComboBox.js</xsl:text>
        </xsl:attribute>    
    </script>   
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/OpenGeo/FilterField.js</xsl:text>
        </xsl:attribute>    
    </script>

    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/FilterBuilder.js</xsl:text>
        </xsl:attribute>
    </script>

    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/WFSSearch.js</xsl:text>
        </xsl:attribute>
    </script>
    
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/FeatureGridResult.js</xsl:text>
        </xsl:attribute>    
    </script> 
    
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/FilterBuilderSelector.js</xsl:text>
        </xsl:attribute>    
    </script>   
    
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/wfsfilterbuilder/js/WFSFilterBuilderButton.js</xsl:text>
        </xsl:attribute>    
    </script> 

    <xsl:choose>
      <xsl:when test="$g_locale = 'fr_CA'">
        <script>
          <xsl:attribute name="src" >
            <xsl:value-of select="$g_widgets_url"/>
            <xsl:text>/wfsfilterbuilder/resources/lang/fr.js</xsl:text>
          </xsl:attribute>
        </script>
      </xsl:when>
      <xsl:otherwise>
        <script>
          <xsl:attribute name="src" >
            <xsl:value-of select="$g_widgets_url"/>
            <xsl:text>/wfsfilterbuilder/resources/lang/en.js</xsl:text>
          </xsl:attribute>
        </script>
      </xsl:otherwise>
    </xsl:choose>
    
    <script> 

        OpenLayers.Format.Filter.v1_0_0.prototype.writers.ogc.PropertyIsLike = function(filter) {
                var node = this.createElementNSPlus("ogc:PropertyIsLike", {
                    attributes: {
                        wildCard: "*", singleChar: ".", escape: "!"
                    }
                });
                // no ogc:expression handling for now
                this.writeNode("PropertyName", filter, node);
                // convert regex string to ogc string
                this.writeNode("Literal", '*'+filter.regex2value()+'*', node);
                return node;
        };
        OpenLayers.Format.Filter.v1_1_0.prototype.writers.ogc.PropertyIsLike = function(filter) {
                var node = this.createElementNSPlus("ogc:PropertyIsLike", {
                    attributes: {
                        matchCase: filter.matchCase,
                        wildCard: "*", singleChar: ".", escapeChar: "!"
                    }
                });
                // no ogc:expression handling for now
                this.writeNode("PropertyName", filter, node);
                // convert regex string to ogc string
                this.writeNode("Literal", '*'+filter.regex2value()+'*', node);
                return node;
        };
           
        var objGPWidget<xsl:value-of select="$WidgetType" /> = new GeoExt.ux.WFSFilterBuilderButton();
        var objGPWidget<xsl:value-of select="$WidgetType" />GeoExtToolbarOptions = objGPWidget<xsl:value-of select="$WidgetType" />;
        
    </script>
  </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="wfsfilterbuilder:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />
    <xsl:variable name="WidgetType">
      <xsl:text>wfsfilterbuilder</xsl:text>
    </xsl:variable>  
    <script>
        
        var pdfUrl = null;
        <xsl:if test="./options/pdfURL">
            pdfUrl="<xsl:value-of select="./options/pdfURL" />";
        </xsl:if>
        
        <!-- deprecated -->
        var csvUrl = null;
        <xsl:if test="./options/csvURL">
            csvUrl="<xsl:value-of select="./options/csvURL" />";
        </xsl:if>
        
        var pdfTitle = null;
        <xsl:if test="./options/pdfTitle">
            pdfTitle="<xsl:value-of select="./options/pdfTitle" />";
        </xsl:if>
        
        <!-- deprecated -->
        var csvTitle = null;
        <xsl:if test="./options/csvTitle">
            csvTitle="<xsl:value-of select="./options/csvTitle" />";
        </xsl:if>
    
        Ext.onReady(function() {
	        
	        var objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions;
	        
	        oMap = objGPWidget<xsl:value-of select="$pMapName" />;
	        
                    
             if (csvUrl != null) {
                 objGPWidget<xsl:value-of select="$WidgetType" />.addAction(csvTitle, csvUrl);
             }
             
             if (pdfUrl != null) {
                 objGPWidget<xsl:value-of select="$WidgetType" />.addAction(pdfTitle, pdfUrl);
             }
             
                <!-- Field titles object to add the titles to the attributes -->
                var fieldsTitles = {};
                
	        <xsl:for-each select="./resources/resource">
	            <!-- Resoruce Name -->
	            <xsl:variable name="resourceName">
	              <xsl:value-of select="." />
	            </xsl:variable>
	            
                    <!-- Adding fields titles to the oject-->
                    <xsl:for-each select="/geoprisma/resources/resource[./name = $resourceName]/fields/field">
                      fieldsTitles['<xsl:value-of select="name" />'] = <xsl:for-each select="title" ><xsl:call-template name="getText" /></xsl:for-each>;
                    </xsl:for-each>

	            <!-- Resource Title -->
	            <xsl:variable name="resourceTitle">
                  <xsl:for-each select="/geoprisma/resources/resource[./name = $resourceName]/title">
                    <xsl:call-template name="getText" />
                  </xsl:for-each>
	            </xsl:variable>
	            
	            <xsl:variable name="pWFSServiceType">
	              <xsl:text>wfs</xsl:text>
	            </xsl:variable>
	            
	            <!-- get service name -->
	            <xsl:variable name="pWFSServiceName">
	              <xsl:call-template name="getDataStoreInfoFromWidget">
	                <xsl:with-param name="pWidgetName" select="$pWidgetName" />
	                <xsl:with-param name="pServiceType" select="$pWFSServiceType" />
	                <xsl:with-param name="pNodeName"><xsl:text>service</xsl:text></xsl:with-param>
	               <xsl:with-param name="pResourceName" select="$resourceName" />
	              </xsl:call-template>
	            </xsl:variable>
	
	            <!-- get layer name -->
	            <xsl:variable name="pWFSLayerName">
	              <xsl:call-template name="getDataStoreInfoFromWidget">
	                <xsl:with-param name="pWidgetName" select="$pWidgetName" />
	                <xsl:with-param name="pServiceType" select="$pWFSServiceType" />
	                <xsl:with-param name="pNodeName"><xsl:text>params/layers</xsl:text></xsl:with-param>
	                <xsl:with-param name="pResourceName" select="$resourceName" />
	              </xsl:call-template>
	            </xsl:variable>
	            
	            function on<xsl:value-of select="$resourceName" />AttributeLoad(attribute, records, options) {
	            
                    <!-- Add the title from fields to attributes -->
                    attribute.each(function(record){
                      recName = record.get('name');
                      <!-- Add the title is not defined, set the title to the attribute name -->
                      recTitle = fieldsTitles[recName] || recName;
                      record.set('title',recTitle);
                    });;
                    <!-- Find all the options for the resource -->
                    var featureConfig = 
                    <xsl:for-each select="//widget[./name = $pWidgetName]">
                      <xsl:call-template name="getObjectFromNode">
                        <xsl:with-param name="pNode" select="./options" />
                      </xsl:call-template>
                    </xsl:for-each>;

                    <!-- allowCSV using WFS service cvsOutputFormat option -->
                    <xsl:variable name="allowCSV">
                      <xsl:choose>
                        <xsl:when test="/geoprisma/services/service[./name = $pWFSServiceName]/options/csvOutputFormat = 'true'">true</xsl:when>
                        <xsl:otherwise>false</xsl:otherwise>
                      </xsl:choose>
                    </xsl:variable>
                    featureConfig['allowCSV'] = <xsl:value-of select="$allowCSV" />;
               
	                var ignoredFields = [];
	                <xsl:if test="/geoprisma/resources/resource[./name = $resourceName]/options/ignoredFields">
	                    <xsl:for-each select="/geoprisma/resources/resource[./name = $resourceName]/options/ignoredFields/ignoredField">
	                        <xsl:variable name="ignoredField">
	                          <xsl:value-of select="." />
	                        </xsl:variable>
	                        ignoredFields.push("<xsl:value-of select="$ignoredField" />");
	                    </xsl:for-each>
	                </xsl:if>
	                <xsl:if test="/geoprisma/resources/resource[./name = $resourceName]/options/ignoredField">
	                    <xsl:variable name="ignoredField">
	                      <xsl:value-of select="/geoprisma/resources/resource[./name = $resourceName]/options/ignoredField" />
	                    </xsl:variable>
	                    ignoredFields.push("<xsl:value-of select="$ignoredField" />");
	                </xsl:if>
	                featureConfig['ignoredFields'] = ignoredFields;

	                <!-- resource 'noLayer' option -->
                        <xsl:choose>
                          <xsl:when test="/geoprisma/resources/resource[./name = $resourceName]/options/noLayer = 'true'">
                            featureConfig['noLayer'] = true;
                          </xsl:when>
                          <xsl:otherwise>
                            featureConfig['noLayer'] = false;
                          </xsl:otherwise>
                        </xsl:choose>

	                <!-- resource "selectorTemplateHeight" and 
                             "selectorTemplateHeight" options -->
                        <xsl:if test="/geoprisma/resources/resource[./name = $resourceName]/options/selectorTemplateHeight">
                          featureConfig["selectorTemplateHeight"] = <xsl:value-of select="/geoprisma/resources/resource[./name = $resourceName]/options/selectorTemplateHeight" />;
                        </xsl:if>
                        <xsl:if test="/geoprisma/resources/resource[./name = $resourceName]/options/selectorTemplateWidth">
                          featureConfig["selectorTemplateWidth"] = <xsl:value-of select="/geoprisma/resources/resource[./name = $resourceName]/options/selectorTemplateWidth" />;
                        </xsl:if>


                    featureConfig['attribute'] = attribute;
	               
                    <!-- Find all the columns and fields for the resource -->
	                var columns = [];
	                var fields = [];
	                for (var i = 0 ; i &lt; attribute.data.length; i++) {
	                    columns.push({
	                            id       : attribute.data.items[i].data.name,
	                            header   : attribute.data.items[i].data.title, 
	                            width    : 100, 
	                            sortable : false, 
	                            dataIndex: attribute.data.items[i].data.name
	                    });
	                    fields.push({
	                          name: attribute.data.items[i].data.name, 
	                          type: attribute.data.items[i].data.type
	                    });
	                }
	                featureConfig['columns'] = columns;
                    featureConfig['fields'] = fields;
                    
                    <!-- Create a new store for the resource -->
	                var storeUrl = Ext.urlAppend("<xsl:value-of select="$proxyurl" />", "osmresource=<xsl:value-of select="$resourceName" />&amp;osmservice=<xsl:value-of select="$pWFSServiceName" />");
	                
	                var store = new gxp.data.WFSFeatureStore({
                        fields: fields,
                        url: storeUrl,
                        featureType: '<xsl:value-of select="$pWFSLayerName" />',
                        resourceName: '<xsl:value-of select="$resourceName" />',
                        proxy: {
                            protocol: {
                                startIndex: 1,
                                maxFeatures: 16
                            }
                        }
                    })
                    featureConfig['resource'] = '<xsl:value-of select="$resourceName" />';
                    featureConfig['store'] = store;
                    
                    <!-- The primary key for the resource -->
                    <xsl:variable name="resourcePrimaryField">
                      <xsl:value-of select="/geoprisma/resources/resource[./name = $resourceName]/options/primaryField" />
                    </xsl:variable>
                    featureConfig.options.primeryField = "<xsl:value-of select="$resourcePrimaryField" />";
	            
	                <!-- Method called on double click  -->
                    <xsl:if test="/geoprisma/resources/resource[./name = $resourceName]/options/selectorMethod">
	                    <xsl:variable name="resourceSelectorMethod">
	                      <xsl:value-of select="/geoprisma/resources/resource[./name = $resourceName]/options/selectorMethod" />
	                    </xsl:variable>
                        featureConfig.options.method = <xsl:value-of select="$resourceSelectorMethod" />;
	                </xsl:if>
                    
                    <xsl:variable name="resourceSelectorTooltip">
                      <xsl:value-of select="/geoprisma/resources/resource[./name = $resourceName]/options/selectorTooltip" />
                    </xsl:variable>
                    <xsl:variable name="resourceSelectorClass">
                      <xsl:value-of select="/geoprisma/resources/resource[./name = $resourceName]/options/selectorClass" />
                    </xsl:variable>
                    featureConfig.options.selectorTooltip = "<xsl:value-of select="$resourceSelectorTooltip" />";
                    featureConfig.options.selectorClass = "<xsl:value-of select="$resourceSelectorClass" />";
	            
	                featureConfig['fieldTitlesByName'] = {};
	                
	                
	                
	                <!-- look for resource field titles -->
				    <xsl:for-each select="//widget[./name = $pWidgetName]">
				          <xsl:for-each select="./options/fields/field">
				            <xsl:variable name="fieldName">
				              <xsl:value-of select="./name" />
				            </xsl:variable>
				
				            <xsl:variable name="fieldType">
				              <xsl:value-of select="./type" />
				            </xsl:variable>
				
				            <xsl:if test="$fieldType = 'key'">
				
				              <!-- Resource field title -->
				              <xsl:variable name="resourceFieldTitle">
				                <xsl:for-each select="/geoprisma/resources/resource[./name = $resourceName]/fields/field[./name = $fieldName]/title">
				                  <xsl:call-template name="getText" />
				                </xsl:for-each>
				              </xsl:variable>
				
				              <xsl:if test="$resourceFieldTitle != ''">
				                objGPWidget<xsl:value-of select="$WidgetType" />.featureConfigs["<xsl:value-of select="$resourceName" />"]['fieldTitlesByName']['<xsl:value-of select="$fieldName" />'] = <xsl:value-of select="$resourceFieldTitle" />;
				              </xsl:if>
				            </xsl:if>
				
				        </xsl:for-each>
                      </xsl:for-each>
	                
	                featureConfig['title'] = <xsl:value-of select="$resourceTitle" />;
	            
	                
	                <!-- Add the store to the widget -->
	                objGPWidget<xsl:value-of select="$WidgetType" />.addFeatureType(featureConfig);
	            }
	            
	        
	            var attributeUrl = Ext.urlAppend("<xsl:value-of select="$proxyurl" />", "osmresource=<xsl:value-of select="$resourceName" />&amp;osmservice=<xsl:value-of select="$pWFSServiceName" />&amp;request=DescribeFeatureType&amp;service=WFS&amp;version=1.1.0&amp;typeName=<xsl:value-of select="$pWFSLayerName"/>");
	                   
               
	            var attribute = new GeoExt.data.AttributeStore({
	                url: attributeUrl
	            });
	            
	            attribute.addListener('load', on<xsl:value-of select="$resourceName" />AttributeLoad);
	            attribute.load();

	            objGPWidget<xsl:value-of select="$WidgetType" />.setMap(objGPWidget<xsl:value-of select="$pMapName" />);

	            <xsl:variable name="queryonclick">
	                <xsl:value-of select="../../options/queryonclick"/>
	            </xsl:variable>
	            <xsl:if test="//geoprisma/widgets/widget[./name = $queryonclick]">
	                objGPWidget<xsl:value-of select="$WidgetType" />.setQueryOnClick(objGPWidget<xsl:value-of select="$queryonclick" />);
	            </xsl:if>
			    
	
	            <!-- Bind 'vectorlayer' widget START -->
	            <xsl:if test="../../options/vectorlayer">
	              <xsl:variable name="WFSVectorLayer">
	                <xsl:value-of select="../../options/vectorlayer" />
	              </xsl:variable>
	              <xsl:if test="//geoprisma/widgets/widget[./name = $WFSVectorLayer]">
	                  objGPWidget<xsl:value-of select="$WidgetType" />.setLayer(window.objGPWidget<xsl:value-of select="$WFSVectorLayer" />);
	              </xsl:if>
	            </xsl:if>
	            <!-- Bind 'vectorlayer' widget END -->
	            
	        </xsl:for-each>  
        });	
    </script>
  </xsl:template>
  <!-- printWidgetExecution END  -->

</xsl:stylesheet>
