<?php
/**
* Class Proxy file when request is a download
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Julien-Samuel Lacroix
* @copyright 2010, Mapgears
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Class Proxy file when request is a download
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage FileProxy
* @author     Julien-Samuel Lacroix
*/ 
class org_geoprisma_proxy_file_FileDownloadProxy extends org_geoprisma_proxy_file_FileProxy
{

    /**
    * Foward the call end return the result
    * 
    * @return void
    */
    public function process()
    {
        $strFilePath = $this->getLayer();

        $objFileTree = new org_geoprisma_proxy_file_FileTree($this->getService()->getSource());

        $objFileTree->download($strFilePath);
    }
    
    /**
    * Retourne le nom de l'action réaliser par le proxy (Create - Read - Update - Delete)
    *                                   
    * @return string
    */
    public function getAction()
    {
        return self::CRUD_READ;    
    }
}

?>
