<?php
/**
* Class Proxy file when request is an upload
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Alexandre Dube
* @copyright 2011, Mapgears
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Class Proxy file when request is an upload
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage FileProxy
* @author     Alexandre Dube
*/ 
class org_geoprisma_proxy_file_FileUploadProxy extends org_geoprisma_proxy_file_FileProxy
{

    /**
    * Foward the call end return the result
    * 
    * @return void
    */
    public function process()
    {
        $strBasePath = $this->getLayer();
        $objFileTree = new org_geoprisma_proxy_file_FileTree($this->getService()->getSource());
        echo $objFileTree->upload($strBasePath);
    }
    
    /**
    * Returns the action this proxy does
    *                                   
    * @return string
    */
    public function getAction()
    {
        return self::CRUD_CREATE;
    }
}

?>
