<?php
/**
* Class Proxy file when request is a view
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Alexandre Lessard
* @copyright 2012, Solution Globale
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Class Proxy file when request is a view
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage FileProxy
* @author     Alexandre Lessard
*/ 
class org_geoprisma_proxy_file_FileViewProxy extends org_geoprisma_proxy_file_FileProxy
{

    /**
    * Foward the call end return the result
    * 
    * @return void
    */
    public function process()
    {
        $strFilePath = $this->getLayer();

        $objFileTree = new org_geoprisma_proxy_file_FileTree($this->getService()->getSource());

        $objFileTree->download($strFilePath, false);
    }
    
    /**
    * Returns the proxy action
    *                                   
    * @return string
    */
    public function getAction()
    {
        return self::CRUD_READ;    
    }
}

?>
