<?php
/**
* Service de type feature server     
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Julien-Samuel Lacroix
* @copyright 2011, Mapgears
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Service de type feature server 
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Service 
* @author     Julien-Samuel Lacroix
*/  
class org_geoprisma_service_WPSService extends org_geoprisma_service_Service
{
    const WPS_SERVICE = 'wps';
    const TYPE = 'wps';
    const TYPE_ID = 11;

    /**
    * Construit un instance de org_geoprisma_service_WPSService
    * 
    * @param array $pobjArray Config
    * 
    * @return org_geoprisma_service_WPSService
    */
    public function __construct($pobjArray) 
    {
        if (isset($pobjArray['id'])) 
        {
            $strName = (string)$pobjArray['id'];
        }
        else
        {
            $strName = (string)$pobjArray['name'];
        }

        $strSource = (string)$pobjArray['source'];
    
        parent::__construct($strName, $strSource, self::TYPE, $pobjArray);
    }

    /**
    * Return the OpenLayers.Layer default options using this type of service.
    * 
    * @param org_geoprisma_config_Config &$pobjConfig Config object
    *
    * @return array 
    */
    public function getDefaultLayerOptions(&$pobjConfig)
    {
        return array(
            'visibility' => 'false',
            'extractAttributes' => 'true'
        );
    }
    
    /**
    *  Ajout le service courant (this) dans le xml     
    * 
    * @param DOMElement  &$pobjDomElementServices Noeud xml ou le service doit être ajouter
    * @param DOMDocument &$pobjDomDocument        Document XMl ou le noeud xml datastore est ajouter, utiliser pour construire les noeuds
    * 
    * @return void
    */
    public function insertIntoXML(DOMElement &$pobjDomElementServices, DOMDocument &$pobjDomDocument)
    {
        $objDomElementService = $pobjDomDocument->createElement('service'); 
        $pobjDomElementServices->appendChild($objDomElementService);        
        $objDomElementType = $pobjDomDocument->createElement('type', self::WPS_SERVICE);
        $objDomElementName = $pobjDomDocument->createElement('name', $this->getName());
        $objDomElementService->appendChild($objDomElementType);
        $objDomElementService->appendChild($objDomElementName);

        // options node
        $objDomElementService->appendChild(
            $this->getDomElements(
                'options', $this->getOptions(), $pobjDomDocument
            )
        );
    }
}
  
?>
