<?php

class org_geoprisma_acl_ACLFactoryTest extends PHPUnit_Framework_TestCase
{
    public function testGetACL()    
    {
        $objACL = org_geoprisma_acl_ACLFactory::getACL();
        $this->assertTrue($objACL instanceof org_geoprisma_acl_ACL);
    }
    
    public function testGetACL2()    
    {
        org_geoprisma_SettingImpl::setACLClass('org_geoprisma_acl_NoACL');
        
        $objACL = org_geoprisma_acl_ACLFactory::getACL();
        $this->assertTrue($objACL instanceof org_geoprisma_acl_NoACL);
    }
    
    public function testGetACL3()    
    {
        org_geoprisma_SettingImpl::setACLClass('org_geoprisma_acl_BorealisACL');
        
        $objACL = org_geoprisma_acl_ACLFactory::getACL();
        $this->assertTrue($objACL instanceof org_geoprisma_acl_BorealisACL);
    }
    
    /**
    * @expectedException org_geoprisma_exception_BadConfigException 
    */
    public function testGetACL4()    
    {
        org_geoprisma_SettingImpl::setACLClass('org_geoprisma_acl_ACLFactoryTest');
        
        org_geoprisma_acl_ACLFactory::getACL();
    }
    
    
    protected function setUp()    
    {  
        $GLOBALS['PHPUNIT_ACLClass'] = org_geoprisma_SettingImpl::getACLClass();
    }                                  
    
    protected function tearDown()    
    {  
        org_geoprisma_SettingImpl::setACLClass($GLOBALS['PHPUNIT_ACLClass']);
    }
}
  
?>