<?php
    
class org_geoprisma_config_XMLConfigTest extends PHPUnit_Framework_TestCase
{
    public function testGetInstance()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $this->assertTrue($objConfig instanceof org_geoprisma_config_XMLConfig);
        $this->assertTrue($objConfig instanceof org_geoprisma_config_Config);
        $this->assertTrue($objConfig instanceof com_borealis_foundation_util_Singleton);    
    } 
   
    public function testReload()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->reload();
    } 
    
    /**
    * @expectedException org_geoprisma_exception_BadXMLConfigFileException 
    */
    public function testReload2()    
    {
        org_geoprisma_SettingImpl::setXMLConfigFile('sidjgfisjdgj');
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->reload();
    } 
    
    /**
    * @expectedException org_geoprisma_exception_BadXMLConfigFileException 
    */
    public function testReload3()    
    {
        org_geoprisma_SettingImpl::setXMLConfigFile(__FILE__);
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->reload();
    }   
    
    public function testGetLayouts()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objArrayLayout = $objConfig->getLayouts();
        $this->assertTrue($objArrayLayout instanceof ArrayObject);        
    }   
    
    public function testGetLayout()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objLayout = $objConfig->getLayout('default');
        $this->assertTrue($objLayout instanceof org_geoprisma_layout_Layout);   
    }
    
    /**
    * @expectedException org_geoprisma_exception_LayoutNotFoundException 
    */
    public function testGetLayout2()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->getLayout('defaultsdfsdf');         
    }
    
    public function testGetDatastores()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objArrayDatastore = $objConfig->getDatastores();
        $this->assertTrue($objArrayDatastore instanceof ArrayObject);        
    }   
    
    public function testGetDatastore()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objDatastore = $objConfig->getDatastore('DSScribble');
        $this->assertTrue($objDatastore instanceof org_geoprisma_datastore_Datastore);   
    }
    
    /**
    * @expectedException org_geoprisma_exception_DatastoreNotFoundException 
    */
    public function testGetDatastore2()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->getDatastore('defaultsdfsdf');         
    }
    
    
    public function testGetWidgets()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objArrayWidget = $objConfig->getWidgets();
        $this->assertTrue($objArrayWidget instanceof ArrayObject);        
    }   
    
    public function testGetWidget()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objWidget = $objConfig->getWidget('DefaultMap');
        $this->assertTrue($objWidget instanceof org_geoprisma_widget_Widget);   
    }
    
    /**
    * @expectedException org_geoprisma_exception_WidgetNotFoundException 
    */
    public function testGetWidget2()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->getWidget('defaultsdfsdf');         
    }
    
    public function testGetResources()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objArrayResource = $objConfig->getResources();
        $this->assertTrue($objArrayResource instanceof ArrayObject);        
    }   
    
    public function testGetResource()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objResource = $objConfig->getResource('ResourceVMap0');
        $this->assertTrue($objResource instanceof org_geoprisma_resource_Resource);   
    }
    
    /**
    * @expectedException org_geoprisma_exception_ResourceNotFoundException 
    */
    public function testGetResource2()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->getResource('defaultsdfsdf');         
    }
    
    public function testGetResource3()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objResource = $objConfig->getResource('ResourceVMap0');         
        
        $this->assertEquals(2, $objResource->getOptions()->count());
    }
    
    public function testGetResource4()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objResource = $objConfig->getResource('ResourceScribble');         
        
        $this->assertEquals(0, $objResource->getOptions()->count());
    }
   
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    */
    public function testGetService()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->getService(123);        
    }  
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    */
    public function testGetService2()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->getService('');        
    } 
    
    public function testGetService3()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objService = $objConfig->getService('FeatureServerDemo');        
        $this->assertTrue($objService instanceof org_geoprisma_service_Service);
        $this->assertTrue($objService instanceof org_geoprisma_service_FeatureServerService);
    }
    
    public function testGetService4()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objService = $objConfig->getService('MetaCartaVM0');        
        $this->assertTrue($objService instanceof org_geoprisma_service_Service);
        $this->assertTrue($objService instanceof org_geoprisma_service_WMSService);
    }
    
    /**
    * @expectedException org_geoprisma_exception_ServiceNotFoundException 
    */
    public function testGetService5()    
    {
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->getService('sdsdf');        
    }   
    
    protected function setUp()    
    {  
        $GLOBALS['XMLConfigFile'] = org_geoprisma_SettingImpl::getXMLConfigFile();
    }
   
    protected function tearDown()    
    {  
        org_geoprisma_SettingImpl::setXMLConfigFile($GLOBALS['XMLConfigFile']); 
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->reload();       
    }
}
  
?>