<?php
    
class org_geoprisma_datastore_DatastoreTest extends PHPUnit_Framework_TestCase
{
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    */
    public function testConstruct()    
    {
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
        $objService = $objConfig->getService('FeatureServerDemo');       
        
        new org_geoprisma_datastore_Datastore(22, $objService, 'sdf');    
    } 
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    */
    public function testConstruct2()    
    {
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
        $objService = $objConfig->getService('FeatureServerDemo');       
        
        new org_geoprisma_datastore_Datastore('sdf', $objService, null);    
    } 
    

    public function testConstruct3()    
    {
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
        $objService = $objConfig->getService('FeatureServerDemo');       
        
        $objDatastore = new org_geoprisma_datastore_Datastore('tomate', $objService, '<params><layers>basic</layers></params>');    
        $this->assertEquals('tomate', $objDatastore->getName());
        $this->assertEquals($objService, $objDatastore->getService());    
    } 
    
    public function testIsAuthorizedLayer()    
    {
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
        $objService = $objConfig->getService('FeatureServerDemo');       
        
        $objDatastore = new org_geoprisma_datastore_Datastore('tomate', $objService, '<params><layers>basic</layers></params>');    
        
        $this->assertEquals(false, $objDatastore->isAuthorizedLayer('tomate'));   
        $this->assertEquals(true, $objDatastore->isAuthorizedLayer('basic'));
    }
    
    public function testGetParams()    
    {
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
        $objService = $objConfig->getService('FeatureServerDemo');       
        
        $objDatastore = new org_geoprisma_datastore_Datastore('tomate', $objService, '<params><layers>basic</layers></params>');    
        
        $this->assertEquals('<params><layers>basic</layers></params>', $objDatastore->getParams());           
    }
    
}
  
?>