<?php

class org_geoprisma_locale_LocaleFactoryTest extends PHPUnit_Framework_TestCase
{
    public function testGetLocale()    
    {
        $objLocale = org_geoprisma_locale_LocaleFactory::getLocale();
        $this->assertTrue($objLocale instanceof org_geoprisma_locale_Locale);
    }
    
    public function testGetLocale2()    
    {
        org_geoprisma_SettingImpl::setLocaleClass('org_geoprisma_locale_GetTextLocale');
        
        $objLocale = org_geoprisma_locale_LocaleFactory::getLocale();
        $this->assertTrue($objLocale instanceof org_geoprisma_locale_GetTextLocale);
    }
    
    /**
    * @expectedException org_geoprisma_exception_BadConfigException 
    */
    public function testGetLocale4()    
    {
        org_geoprisma_SettingImpl::setLocaleClass('org_geoprisma_locale_LocaleFactoryTest');
        
        org_geoprisma_locale_LocaleFactory::getLocale();
    }
    
    
    protected function setUp()    
    {  
        $GLOBALS['PHPUNIT_LocaleClass'] = org_geoprisma_SettingImpl::getLocaleClass();
    }                                  
    
    protected function tearDown()    
    {  
        org_geoprisma_SettingImpl::setLocaleClass($GLOBALS['PHPUNIT_LocaleClass']);
    }
}
  
?>