<?php

class org_geoprisma_locale_LocaleTest extends PHPUnit_Framework_TestCase
{

    public function testGetText()    
    {        
        $this->assertEquals('', org_geoprisma_locale_Locale::getText('','sdgdsg'));
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    */
    public function testGetText2()    
    {
        org_geoprisma_locale_Locale::getText('saf','');
    }
    
    public function testGetText3()    
    {
        // Domaine inexistant
        $this->assertEquals('saf', org_geoprisma_locale_Locale::getText('saf','sdgdsg'));
    }
    
    public function testGetText4()    
    {
        $objLocale = org_geoprisma_locale_LocaleFactory::getLocale();
        
        // Clé inexistante
        $this->assertEquals('safsdf', org_geoprisma_locale_Locale::getText('safsdf','sample1'));
        
        // Clé existante     
        $objLocale->setLanguage('en_CA');  
        $this->assertEquals('phpunit_test', org_geoprisma_locale_Locale::getText('phpunit_test','sample1'));
            
        $objLocale->setLanguage('en_US');   
        $this->assertEquals('en_US Test message', org_geoprisma_locale_Locale::getText('phpunit_test','sample1'));
          
        $objLocale->setLanguage('fr_CA'); 
        $this->assertEquals('fr_CA Test de traduction, écrire noël poinçon être & @ ±', org_geoprisma_locale_Locale::getText('phpunit_test','sample1'));        
        
        $this->assertEquals(2, mb_strlen('Éë', 'UTF-8'));
    }
    
    public function testGetText5()    
    {        
        $this->assertEquals('"saf"', org_geoprisma_locale_Locale::getText('saf','abcdef','JS'));
        $this->assertEquals('"saf\u00c9"', org_geoprisma_locale_Locale::getText('safÉ','abcdef','js'));
        
        $this->assertEquals('&lt;a href=&#039;test&#039;&gt;Test&lt;/a&gt;', org_geoprisma_locale_Locale::getText("<a href='test'>Test</a>",'abcdef','HTML'));
        $this->assertEquals('&lt;a href=&#039;test&#039;&gt;Test&lt;/a&gt;', org_geoprisma_locale_Locale::getText("<a href='test'>Test</a>",'abcdef','html'));        
    }
    
    public function testGetLanguage()    
    {
        $objLocale = org_geoprisma_locale_LocaleFactory::getLocale();    
        $objLocale->setLanguage('en_US');                                   
        $this->assertEquals('en_US', $objLocale->getLanguage());
        $objLocale->setLanguage('fr_CA');                                   
        $this->assertEquals('fr_CA', $objLocale->getLanguage());
    }
    
    public function testGetLocaleLanguageDefault()    
    {
        $objLocale = org_geoprisma_locale_LocaleFactory::getLocale();    
                                           
        $this->assertEquals(org_geoprisma_SettingImpl::getLocaleLanguageDefault(), $objLocale->getDefaultLanguage());
        $_REQUEST[org_geoprisma_SettingImpl::getLocaleLanguageRequest()] = 'abcd';                          
        $this->assertEquals('abcd', $objLocale->getDefaultLanguage());    
    }
    
    public function testGetLocaleLanguageDefault2()    
    {
        $objLocale = org_geoprisma_locale_LocaleFactory::getLocale();    
                                           
        $this->assertEquals(org_geoprisma_SettingImpl::getLocaleLanguageDefault(), $objLocale->getDefaultLanguage());
        $_REQUEST[org_geoprisma_SettingImpl::getLocaleLanguageRequest()] = 'abcd';                          
        $this->assertEquals('abcd', $objLocale->getDefaultLanguage());
        $_REQUEST[org_geoprisma_SettingImpl::getLocaleLanguageRequest()] = null;                          
        $this->assertEquals('abcd', $objLocale->getDefaultLanguage()); 
        $this->assertEquals('abcd', $_SESSION[org_geoprisma_SettingImpl::getLocaleLanguageRequest()]);        
    }
    
    public function setUp()
    {
        $objLocale = org_geoprisma_locale_LocaleFactory::getLocale();                                        
        $GLOBALS['PHPUNIT_Language'] = $objLocale->getLanguage();
    } 
    
    public function tearDown()
    {
        unset($_REQUEST[org_geoprisma_SettingImpl::getLocaleLanguageRequest()]);
        $objLocale = org_geoprisma_locale_LocaleFactory::getLocale();                                        
        $objLocale->setLanguage($GLOBALS['PHPUNIT_Language']);                                         
    }
}
  
?>