<?php
    
class org_geoprisma_proxy_wms_WMSProxyTest extends PHPUnit_Framework_TestCase
{

    public function testProcess()    
    {
        $_REQUEST['osmservice'] = 'GTOPO30_local_WMS';
        $_REQUEST['osmresource'] = 'Resource_GTOPO30_local_WMS'; 
    
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();  
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy); 
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_wms_WMSProxy);               
        
        $objArrayTemp = $_GET; 
        
        $_GET = array();
        $_GET['LAYERS'] = 'GTOPO30';
        $_GET['SERVICE'] = 'WMS';   
        $_GET['VERSION'] = '1.1.1';
        $_GET['REQUEST'] = 'GetMap';
        $_GET['STYLES'] = '';  
        $_GET['EXCEPTIONS'] = 'application/vnd.ogc.se_inimage';
        $_GET['FORMAT'] = 'image/jpeg';     
        $_GET['SRS'] = 'EPSG:4326'; 
        $_GET['BBOX'] = '-11.25,33.75,0,45';
        $_GET['WIDTH'] = '256';
        $_GET['HEIGHT'] = '256';
    
        ob_start();
        $objProxy->process();    
        $strJPEG = ob_get_contents();
        ob_end_clean();
        
        header("Content-Type: text/plain"); 
        $_GET = $objArrayTemp;

        $this->assertEquals(8806, strlen($strJPEG));
    }
    
    public function testGetLayers()    
    {
        $objArrayLayers = org_geoprisma_proxy_wms_WMSProxy::getLayers(); 
        $this->assertTrue($objArrayLayers instanceof ArrayObject);
        $this->assertEquals(0, count($objArrayLayers));
        
        $objArrayTemp = $_GET; 
        $_GET = array();
        $_GET['LAYERS'] = 'basic';
        $objArrayLayers = org_geoprisma_proxy_wms_WMSProxy::getLayers();
        $_GET = $objArrayTemp;  
        
        $this->assertTrue($objArrayLayers instanceof ArrayObject);
        $this->assertEquals(1, count($objArrayLayers));                       
    }
    
    
}
  
?>