<?php 

class org_geoprisma_uirender_UITest extends PHPUnit_Framework_TestCase
{
    public function testConstruct()    
    {
        new org_geoprisma_uirender_UI('HelloWorld');
    }  
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    */
    public function testConstruct2()    
    {
        new org_geoprisma_uirender_UI('');
    } 
    
    /**
    * @expectedException org_geoprisma_exception_LayoutNotFoundException 
    */
    public function testConstruct3()    
    {
        new org_geoprisma_uirender_UI('sdfsdf');
    } 
    
    public function testRender()    
    {
        $objUI = new org_geoprisma_uirender_UI('HelloWorld');
        
        $strResult = $objUI->render();

        $objSimpleXMLElement =  new SimpleXMLElement($strResult);
        
        $this->assertEquals('$g_widgets_dir', (string)$objSimpleXMLElement->body->table->tr[2]->td[0]);
        $this->assertEquals(org_geoprisma_SettingImpl::getWidgetDir(), (string)$objSimpleXMLElement->body->table->tr[2]->td[1]);
        $this->assertEquals('$g_lib_url', (string)$objSimpleXMLElement->body->table->tr[3]->td[0]); 
        $this->assertEquals(org_geoprisma_SettingImpl::getLibUrl(), (string)$objSimpleXMLElement->body->table->tr[3]->td[1]);
        $this->assertEquals('$g_template_url', (string)$objSimpleXMLElement->body->table->tr[4]->td[0]); 
        $this->assertEquals(org_geoprisma_SettingImpl::getTemplateUrl(), (string)$objSimpleXMLElement->body->table->tr[4]->td[1]);
        $this->assertEquals('$g_widgets_url', (string)$objSimpleXMLElement->body->table->tr[5]->td[0]); 
        $this->assertEquals(org_geoprisma_SettingImpl::getWidgetUrl(), (string)$objSimpleXMLElement->body->table->tr[5]->td[1]);        
    }
    
    public function testRender2()    
    {
        $objUI = new org_geoprisma_uirender_UI('HelloWorld_Param');
        
        $strResult = $objUI->render( array( array('key' => 'g_ex_test1', 'value' => 'phpunit test'), array('key' => 'g_ex_test2', 'value' => true) ) );

        $objSimpleXMLElement =  new SimpleXMLElement($strResult);
        
        $this->assertEquals('$g_widgets_dir', (string)$objSimpleXMLElement->body->table->tr[2]->td[0]);
        $this->assertEquals(org_geoprisma_SettingImpl::getWidgetDir(), (string)$objSimpleXMLElement->body->table->tr[2]->td[1]);
        $this->assertEquals('$g_lib_url', (string)$objSimpleXMLElement->body->table->tr[3]->td[0]); 
        $this->assertEquals(org_geoprisma_SettingImpl::getLibUrl(), (string)$objSimpleXMLElement->body->table->tr[3]->td[1]);
        $this->assertEquals('$g_template_url', (string)$objSimpleXMLElement->body->table->tr[4]->td[0]); 
        $this->assertEquals(org_geoprisma_SettingImpl::getTemplateUrl(), (string)$objSimpleXMLElement->body->table->tr[4]->td[1]);
        $this->assertEquals('$g_widgets_url', (string)$objSimpleXMLElement->body->table->tr[5]->td[0]); 
        $this->assertEquals(org_geoprisma_SettingImpl::getWidgetUrl(), (string)$objSimpleXMLElement->body->table->tr[5]->td[1]);   
        $this->assertEquals('$g_ex_test1', (string)$objSimpleXMLElement->body->table->tr[8]->td[0]); 
        $this->assertEquals('phpunit test', (string)$objSimpleXMLElement->body->table->tr[8]->td[1]); 
        $this->assertEquals('$g_ex_test2', (string)$objSimpleXMLElement->body->table->tr[9]->td[0]); 
        $this->assertEquals('1', (string)$objSimpleXMLElement->body->table->tr[9]->td[1]);      
    } 
    
    public function testGetValueFrom()    
    {
        $this->assertEquals('""', org_geoprisma_uirender_UI::getValueFrom('')); 
        $this->assertEquals('123', org_geoprisma_uirender_UI::getValueFrom('123'));
        $this->assertEquals('123.25', org_geoprisma_uirender_UI::getValueFrom('123.25'));
        $this->assertEquals('"asdasd"', org_geoprisma_uirender_UI::getValueFrom('asdasd'));
        $this->assertEquals('true', org_geoprisma_uirender_UI::getValueFrom('true'));
        $this->assertEquals('false', org_geoprisma_uirender_UI::getValueFrom('false'));
    }  
    
    public function testGetValueFrom2()    
    {
        $GLOBALS['geoprisma_test_get_value_from'] = true;
        $this->assertEquals('1', org_geoprisma_uirender_UI::getValueFrom('$GLOBALS[geoprisma_test_get_value_from]'));
        
        $GLOBALS['geoprisma_test_get_value_from'] = false;
        $this->assertEquals('false', org_geoprisma_uirender_UI::getValueFrom('".($GLOBALS["geoprisma_test_get_value_from"]?"true":"false")."'));
        $GLOBALS['geoprisma_test_get_value_from'] = true;
        $this->assertEquals('true', org_geoprisma_uirender_UI::getValueFrom('".($GLOBALS["geoprisma_test_get_value_from"]?"true":"false")."'));    
        
        $GLOBALS['geoprisma_test_get_value_from'] = 'true';
        $this->assertEquals('true', org_geoprisma_uirender_UI::getValueFrom('$GLOBALS[geoprisma_test_get_value_from]'));
        $GLOBALS['geoprisma_test_get_value_from'] = 'false';
        $this->assertEquals('false', org_geoprisma_uirender_UI::getValueFrom('$GLOBALS[geoprisma_test_get_value_from]'));
        
        $GLOBALS['geoprisma_test_get_value_from'] = '12.25';
        $this->assertEquals('12.25', org_geoprisma_uirender_UI::getValueFrom('$GLOBALS[geoprisma_test_get_value_from]'));
        $GLOBALS['geoprisma_test_get_value_from'] = '145';
        $this->assertEquals('145', org_geoprisma_uirender_UI::getValueFrom('$GLOBALS[geoprisma_test_get_value_from]'));
        
        $GLOBALS['geoprisma_test_get_value_from'] = 'A"llo';
        $this->assertEquals('"A\"llo"', org_geoprisma_uirender_UI::getValueFrom('$GLOBALS[geoprisma_test_get_value_from]'));        
    }
    
    public function testGetValueFrom3()    
    {
        $this->assertEquals('"allo"', org_geoprisma_uirender_UI::getValueFrom('return "allo";', false)); 
    }

}

?>